Attribute VB_Name = "HtmlLink"
' HTML Link Checker Ɋւ郂W[
' (C) 2002  
Option Explicit
Option Compare Binary

'--------------------

Private Type LinkAttribute
    Name As String       ' B : "href"
    Required As Boolean  ' ̑K{ǂB
End Type

Private Type LinkTagStructure  ' Nt@CɊւ鑮^O̎
    Name As String             ' ^OB : "a", "img", ...
    Attrib() As LinkAttribute  ' B{IɁAvf͈ƂȂ邱ƂB
End Type

Public LinkTag() As LinkTagStructure

Public strgLinkTagName() As String  ' LinkTag() źAName vfW߂zB
                                    ' 璷ȃf[^ł͂邪A邽߁A
                                    ' č쐬B
Public strgLinkTagHeads As String  ' Like ZeՂɂ邽߁ALinkTagName ̈ꕶ
                                   ' W߂BJoinTopLetter() ֐ō쐬B

'--------------------

Private Type CheckComment
    Id As Long         ' x ID
    Message As String  ' ̓IȌxbZ[W
End Type

Private Type HtmlAttribute
    Name As String       ' B : "href"
    Value As String      ' lB : "'sample.htm'"
                         ' ̓́A HTML t@C
                         ' LڂĂʂ̂̂B
    FullPath As String   ' Value tpXɒ́B
    Line As Long         ' HTML t@CɂALqJnsB
                         ' ^O̊JnʒuÅJnʒuÅJnʒûǂ
                         ' ̗p邩́AbytgLineOption ̒lɂĐݒ肷B
    RealLine As Long     ' HTML t@CɂAl̋LqJnsB
                         ' name/id dĂꍇAũAJ[͊Ɂsڂ
                         ' LqĂ܂BvƂxoƂɂȂ邪A̍s
                         ' ^O⑮łȂAl̍słȂƕsRB
                         ' ]đl̍śAɏ Line Ƃ͕ʓrɕێB
    Status As Long       ' N󋵂Ȃǂ̃Xe[^X
    Comment() As CheckComment  ' Status ɉAOɋLڂRg
End Type

Private Type HtmlTag
    Name As String  ' ^OB : "a"
                    ' HTML t@CɋLڂĂʂ̂̂B
    Id As Long      ' Name ALinkTag() ẑǂ index ̃^Oɑ邩B
                    ' LinkTag() zɂ index ԍi[B
    Attrib() As HtmlAttribute  ' iKvȁjLq̔zB
                    ' "Attribute" ƂÓAVB G[ƂĒeߎgȂB
    Line As Long    ' ^ŐLqJnsB
    Status As Long  ' ^OɊւXe[^XB
    Comment() As CheckComment  ' Status ɉAOɋLڂRg
    RevMade As Boolean  ' <link> ^O rev="made" LqĂ邩ǂ̃tOB
End Type

Private Type HtmlAnchor
    TagId As Long     ' ^Ozɂ Index ԍ
    AttribId As Long  ' zɂ Index ԍ
    Linked As Long    ' 烊NĂ
    Doubled As Byte   ' y[WŁAAJ[`̏dNĂ邩ǂ̃tOB
                      ' 0 = ȂB 1 = Case Igonore ŏdB
                      ' 2 = Case Sensitive ŏdB
End Type

Public Type HtmlFileStructure
    Name As String       ' t@C̃pX
    Anchor() As HtmlAnchor  ' <a name="..."> ŋLqꂽ Anchor ̔zB
    Tag() As HtmlTag     ' HtmlTag \̂̔zB{IɁAKvȃ^OɂĂ̂ݍ쐬B
    Linked As Long       ' 烊NĂ
    Status As Long       ' ɊւXe[^XBႦΓǂݍ݂ɎsȀB
    Comment() As CheckComment  ' Status ɉAOɋLڂRg
End Type

Public HtmlFile() As HtmlFileStructure

'--------------------

Public Type CheckSetStructure
    SetName As String
    LocalPath As String  ' [J HDD ɂfBNg̃pX
    Url As String  ' LocalPath ɑΉ URL
    DefaultDocument() As String  ' ftHg hLg̔z
    HtmlFilePattern() As String
    HtmlFilePatternL() As String
    AllowBackSlash As Byte  ' pXLq "\" ̎gpF߂邩B
    AllowLocalFullPath As Byte  ' [J̃tpXLqF߂邩B
    CheckMailTo As Byte  ' "mailto:" ̂ƂɃ[AhXꍇAx邩B
    CheckBaseDirOver As Byte  ' fBNgQƂ鑊΃Nx邩B
    AlertDirListing As Byte  ' ftHg hLg߂ɃfBNg
                             ' QƂĂꍇAx邩B
    StrictAnchorDescription As Byte  ' AJ[Lq̕sȕo邩B
    AlertIgnoredFile As Byte  ' ǂNĂȂiǗjt@Cx邩B
    AlertIgnoredNameAnchor As Byte  ' Ǘ name AJ[x邩B
    AlertIgnoredIdAnchor As Byte  ' Ǘ id AJ[x邩B
    '---------
    FileAttribute As Byte
    FilePatternXEnabled As Byte
    FilePatternX() As String  ' Like Zpp^[łȂADOS `̃p^[LqB
    DirAttribute As Byte
    DirPatternXEnabled As Byte
    DirPatternX() As String  ' Like Zpp^[łȂADOS `̃p^[LqB
End Type

Public CheckSet() As CheckSetStructure

'--------------------

Public lnggSetId As Long  ' ݏ́A`FbNZbgz index ԍ

' HtmlAttribute \̂ Line A̍s\邩̃IvVB
' 0 : ^O̊Jnʒu ^ 1 : ̊Jnʒu ^ 2 : l̊Jnʒu
Public bytgLineOption As Byte

Public strgIniFileName As String  ' INI t@C
Public strgHelpFileName As String   ' wvt@C

Public strgLogFileDirectory As String  ' Ot@C̏ofBNg̃pX
Public bytgLogFileIncrement As Byte  ' Ot@CCNg邩B
Public bytgLogType As Byte  ' Ot@Č`B0 = Text, 1 = CSV, 2 = Tab Text
Public bytgAlwaysLogRemoteLink As Byte  ' [g`FbNȂꍇOɂ͏oB
Public bytgTrimLogPath As Byte  ' Oɏot@CAg~O邩B
Public bytgUseSlashLogPath As Byte  ' Oɏot@CŁAXbV(/)gB
Public bytgFileNameCaseSensitive As Byte  ' t@C̑^ʂ邩B

Public lnggLastWindowTop As Long
Public lnggLastWindowLeft As Long

Public boolgExecuting As Boolean  ' tOB̃LẐ߂ɕKvB

' id/name ̑ۂ𔻒肷邽߂́ALike Zpp^[B
Public Const strgIdStartL As String = "[Ii][Dd][" & vbTab & vbLf & vbCr & " =]*"
Public Const strgIdL As String = "*[" & vbTab & vbLf & vbCr & " ""']" & strgIdStartL
'Public Const strgNameStartL As String = "[Nn][Aa][Mm][Ee][" & vbTab & vbLf & vbCr & " =]*"
'Public Const strgNameL As String = "*[" & vbTab & vbLf & vbCr & " ""']" & strgNameStartL

' wv\EÎ߂ API 錾i32 rbgŁjB
' Books Online ɂ錾 16 rbgłȂ̂ŒӁB
Declare Function WinHelp Lib "user32" Alias "WinHelpA" ( _
    ByVal hWnd As Long, ByVal lpHelpFile As String, _
    ByVal wCommand As Long, ByVal dwData As Long) As Long


'=====================================================================
' CheckComment \̂̔zɁAVKvfǉB
'---------------------------------------------------------------------
'  : TargetArray() : vfǉ CheckComment \́B
'        lngId         : x ID
'        strMessage    : xbZ[W
'---------------------------------------------------------------------
' ߂l : 0 : I
'          1 : G[I
'---------------------------------------------------------------------
Public Function AddCheckComment( _
    TargetArray() As CheckComment, lngId As Long, strMessage As String) As Byte

    On Error GoTo ErrorHandler
    
    Dim lngUBound As Long:  lngUBound = UBound(TargetArray)
    
    If Len(TargetArray(lngUBound).Message) > 0 Then
        lngUBound = lngUBound + 1
        ReDim Preserve TargetArray(LBound(TargetArray) To lngUBound)
    End If
    
    TargetArray(lngUBound).Id = lngId
    TargetArray(lngUBound).Message = strMessage
    
    AddCheckComment = 0

    Exit Function
    
ErrorHandler:
    AddCheckComment = 1

End Function


'=====================================================================
' HtmlAttribute \̂󂯎AValue o FullPath orB
' ҂̒lقȂꍇ͊ʂ FullPath oAȂ΋󕶎ԂB
' LinkCheckLocal ȂǂĂ΂AX[u֐B
'---------------------------------------------------------------------
'  : TargetAttrib : Ώۂ HtmlAttribute \
'---------------------------------------------------------------------
' ߂l : ʂ FullPath oA邢͋󕶎B
'---------------------------------------------------------------------
Public Function AddLinkFullPath( _
    TargetAttrib As HtmlAttribute) As String

    On Error GoTo ErrorHandler
    
    If AoyeHtml.TrimQuote(TargetAttrib.Value) = TargetAttrib.FullPath Then
        AddLinkFullPath = ""
    Else
        AddLinkFullPath = vbCrLf & "(N : " & TargetAttrib.FullPath & ")"
    End If

    Exit Function
    
ErrorHandler:
    AddLinkFullPath = ""

End Function


'=====================================================================
' ݒς݂ HtmlFileStructure 󂯎Aݒ肳Ă鑮l΃pXɑB
' TargetFile.Status  0 ƂOŏ͊JnB
'---------------------------------------------------------------------
'  : TargetFile : ΏۂƂȂ HtmlFileStructure \́B
'                     ConstructHtmlFileStructure() ֐Ŗ߂l 4 ƂȂĂ̂OB
'        strCheckSetServer : ݂̃`FbNZbg URL ̃T[oB
'                            i<base> ^O̎w肪ȂȂ΁j
'                            strBasePathServer ֑ŁA
'                            VerifyLinkAttribute() ֐̈ƂĎĝŁA
'                            ̃RgQƂ̂ƁB
'---------------------------------------------------------------------
' ߂l : TargetFile.Status Ɋi[ꂽlB
'           TargetFile  ConstructHtmlFileStructure() ֐ŏςƂOȂ̂ŁA
'          ߂l 4, 5, 99 ̂ꂩƂƂɂȂB
'---------------------------------------------------------------------
Public Function AnalyzeHtmlFileStructure( _
    TargetFile As HtmlFileStructure, strCheckSetServer As String) As Byte

    On Error GoTo ErrorHandler
    
    Dim lngT As Long
    Dim lngA As Long
    Dim lngBaseTagLine As Long  ' ŏ <base> ^OosB
    Dim strBasePath As String  ' t@Cg̃pXA邢 <base> ^O href lB
    Dim bytBasePathStatus As Byte  ' strBasePath ̏ԃtOB
                                   ' 0 : sl ^ 1 : [J ^ 2 : [g
    Dim strTagName As String  ' ꎞobt@
    Dim strAttribName As String
    Dim lngUBound As Long
    Dim lngReturnValue As Long
    Dim strMessage As String
    
    Dim strBasePathServer As String  ' ȉ 5  VerifyLinkAttribute() ֐ɓnB
    Dim strBasePathParent As String
    Dim strRelativeBaseServer As String
    Dim strRelativeBaseDir() As String:  ReDim strRelativeBaseDir(0 To 0)
    Dim boolRelativeBaseStatus As Boolean
    
    Dim lngBaseTagCounter As Long  ' <base> ^Oo񐔂̃JE^B
    
    ' ꎞobt@
    Dim strTempFullPath As String
    Dim strTempDirPath As String
    Dim strTempFilePath As String
    Dim strSplitter As String
    
    
    '-----------------------------------
    ' <base> ^OɊւ鏈
    '-----------------------------------
    
    ' ܂A^O̒ <base> ^O܂܂ĂȂ`FbNB
    For lngT = LBound(TargetFile.Tag()) To UBound(TargetFile.Tag())
    
        strTagName = TargetFile.Tag(lngT).Name
    
        If strTagName Like "[Bb][Aa][Ss][Ee]" Then  ' <base> ^OȂ΁A
            ' osLB
            lngBaseTagLine = TargetFile.Tag(lngT).Line
            
            ' ̏o񐔂mFB
            If VerifyAttributeArray(TargetFile.Tag(lngT)) = 1 Then GoTo ErrorHandler
            
            ' href `ĂȂ΁A
            If TargetFile.Tag(lngT).Status > 0 Then
                bytBasePathStatus = 0  ' sK؂ <base> ^OLqtOB
            
            ' href S`ĂȂȂ΁A
            ElseIf TargetFile.Tag(lngT).Attrib(0).Name = "" Then
                ' ̃t@Cg̃pXpXƂč̗pB
                strBasePath = TargetFile.Name
                bytBasePathStatus = 1  ' [JpX̃tO𗧂ĂB
                
            ' href 񂾂`ĂȂ΁A
            Else
                ' ̋Lq܂Ƃł邩؁B
                lngReturnValue = VerifyBasePath(TargetFile.Tag(lngT), 0)
                
                If (lngReturnValue Mod 100) <= 1 Then  ' ܂ƂłȂA
                    ' i [JtpXLq́AxΏۂƂ͂Ȃ邩ȂA
                    '      pXLqƂĂ͏ɂ܂ƂƂ݂Ȃj
                    
                    ' strBasePath 擾A
                    strBasePath = TargetFile.Tag(lngT).Attrib(0).FullPath
                    If strBasePath Like "[A-Za-z]:*" Or strBasePath Like "\\[A-Za-z]*" Then
                        bytBasePathStatus = 1  ' [J <base> ^OLqtOB
                    Else
                        bytBasePathStatus = 2  ' [g <base> ^OLqtOB
                    End If
                
                Else  ' ܂ƂłȂȂA
                    bytBasePathStatus = 0  ' sK؂ <base> ^OLqtOB
                End If
              
            End If

            Exit For
        
        ' 邢́A<body> ^OoȂ΁Aȍ~ <base> ^O͖B
        ElseIf strTagName Like "[Bb][Oo][Dd][Yy]" Or strTagName Like "[Aa]" Then
            Exit For
        End If
    Next lngT
    ' <base> ^OȂȂ΁At@Cg̃pXpXƂB
    If lngBaseTagLine = 0 Then
        strBasePath = TargetFile.Name
        bytBasePathStatus = 1  ' [JpX̃tO𗧂ĂB
    End If
    ' ȏAo <base> ^OɊւ鏈B
    
    '-----------------------------------
    ' VerifyLinkAttribute() ֐ɓnݒB
    '-----------------------------------
    
    If bytBasePathStatus > 0 Then
    
        '  ΃pX̉ɎgpXB
        ' <base> ^O̎w肪Ȃ΁A
        If lngBaseTagLine > 0 Then
            If bytBasePathStatus > 0 Then  ' ꂪLȒlꍇA
                strBasePathServer = ServerPath(strBasePath)  ' ̃T[ogB
            End If
        ' <base> ^OꍇA
        Else
            If strCheckSetServer <> "" Then  ' `FbNZbg URL w肳ĂȂA
                strBasePathServer = strCheckSetServer  ' ̃T[ogB
            End If
        End If
    
        '  Aʂւ̑΃NɎgpXB
        strBasePathParent = AoyeFilePath.ParentDirectory(strBasePath, "")
        
        '  ʂւ̑΃NɎgpXB
        ' strBasePath `FbNZbg̊fBNgĂA
        ' `FbNZbg URL w肳ĂȂ΁A
        ' strBasePath 񃊃[g URL ֏A̐؂蕪ʂ
        ' VerigyLinkAttribute() ɓnBłȂȂAstrBasePath ̐؂蕪ʂnB
        If StrCompDos(Left$(strBasePath, Len(CheckSet(lnggSetId).LocalPath)), _
                      CheckSet(lnggSetId).LocalPath) = 0 And _
           CheckSet(lnggSetId).Url <> "" Then
            boolRelativeBaseStatus = True
            strTempFullPath = CheckSet(lnggSetId).Url & _
                              Mid$(strBasePath, Len(CheckSet(lnggSetId).LocalPath) + 1)
            ' fBNg̋؂L "/" őB
            strSplitter = "/"
            strTempFullPath = AoyeFilePath.NormalizePathSplitter( _
                                  strTempFullPath, strSplitter)
        Else
            boolRelativeBaseStatus = False
            strTempFullPath = strBasePath
            ' fBNg̋؂L擾B
            strSplitter = AoyeFilePath.DetectPathSplitter(strTempFullPath)
        End If
        
        ' T[oAfBNgAt@C֐؂蕪B
        Call AoyeFilePath.SplitPathExpression(strTempFullPath, strSplitter, _
                 strRelativeBaseServer, strTempDirPath, strTempFilePath)
        ' fBNgLqɐ؂蕪B
        Call AoyeFilePath.SplitStringByLetter(strTempDirPath, strSplitter, _
                                              strRelativeBaseDir())
    End If
    
    '-----------------------------------
    ' e^OɂďB
    '-----------------------------------
    
    For lngT = LBound(TargetFile.Tag()) To UBound(TargetFile.Tag())
    
        strTagName = TargetFile.Tag(lngT).Name   ' ꎞobt@ɗ߂B
    
        ' t@CɊY^OȂȂ΁A[v𔲂B
        If strTagName = "" Then Exit For
    
        ' <base> ^ȌꍇA
        If strTagName Like "[Bb][Aa][Ss][Ee]" Then
            lngBaseTagCounter = lngBaseTagCounter + 1
            strMessage = ""
            
            ' 2 ڈȍ~ <base> ^OȂ΁A
            If lngBaseTagCounter > 1 Then
                TargetFile.Tag(lngT).Status = 4
                strMessage = "<" & strTagName & "> ^O͊ " & _
                             lngBaseTagLine & " sڂŋLqĂ܂B"
            ' 1 ڂǂA<body> ZNVɂȂ΁A
            ElseIf lngBaseTagLine = 0 Then
                TargetFile.Tag(lngT).Status = 5
                strMessage = "<" & strTagName & "> ^O <head> ZNV" & _
                             "LqȂ΂Ȃ܂B"
            End If
            
            If strMessage <> "" Then
                Call AddCheckComment(TargetFile.Tag(lngT).Comment(), _
                                     TargetFile.Tag(lngT).Status, strMessage)
            End If
            
        ' <base> ^OȊȌꍇAedĂ邩A邢͕K{ĂȂA
        ' `FbNBG[NɃ`FbNłȂ΁A
        ElseIf VerifyAttributeArray(TargetFile.Tag(lngT)) = 0 Then
                       
            ' ^O̊eɂāA
            For lngA = 0 To UBound(TargetFile.Tag(lngT).Attrib())
                strAttribName = TargetFile.Tag(lngT).Attrib(lngA).Name
                ' Anchor ƂȂ鑮Ȃ΁A
                ' iname  <a> ^Oł̂ݗLƂOj
                If strAttribName Like "[Ii][Dd]" Or _
                   strAttribName Like "[Nn][Aa][Mm][Ee]" Then
                    ' Anchor z֒ǉB
                    lngUBound = UBound(TargetFile.Anchor)
                    If TargetFile.Anchor(lngUBound).TagId >= 0 Then
                        lngUBound = lngUBound + 1
                        ReDim Preserve TargetFile.Anchor(LBound(TargetFile.Anchor) _
                                                                To lngUBound)
                    End If
                    TargetFile.Anchor(lngUBound).TagId = lngT
                    TargetFile.Anchor(lngUBound).AttribId = lngA
                    ' Xe[^XlݒB
                    TargetFile.Tag(lngT).Attrib(lngA).Status = 500
                
                ' Anchor łȂA܂pXLq̑Ȃ΁A
                Else
                    ' l΃pXɒB
                    Call VerifyLinkAttribute( _
                             TargetFile, lngT, lngA, _
                             bytBasePathStatus, strBasePathServer, _
                             strBasePathParent, _
                             strRelativeBaseServer, strRelativeBaseDir(), _
                             boolRelativeBaseStatus)
                End If
            Next lngA
            
        ' ̏d^@`FbNŉ炩̃G[NꍇB
        Else
            TargetFile.Tag(lngT).Status = 99
            Call AddCheckComment( _
                     TargetFile.Tag(lngT).Comment(), _
                     TargetFile.Tag(lngT).Status, _
                     "̗L̃`FbNɎs܂B")
        End If
    Next lngT
    
    AnalyzeHtmlFileStructure = TargetFile.Status
    
    Exit Function
    
ErrorHandler:
    TargetFile.Status = 99
    Call AddCheckComment( _
             TargetFile.Comment(), _
             TargetFile.Status, _
             "HTML \̉͒ɖm̃G[N܂B")
    AnalyzeHtmlFileStructure = TargetFile.Status
    
End Function


'=====================================================================
' HtmlFile() z̊evfɂāA탊NԂ؂A
' KvɉăbZ[WǉB
'---------------------------------------------------------------------
'  :
'
'---------------------------------------------------------------------
' ߂l : 0 : I
'          1 : G[I
'---------------------------------------------------------------------
Public Function AnalyzeLinkedStatus( _
    ) As Byte

    On Error GoTo ErrorHandler
    
    Dim lngF As Long
    Dim lngT As Long
    Dim lngA As Long
    Dim lngH As Long
    
    Dim strName As String
    Dim strValue As String
    
    For lngF = LBound(HtmlFile) To UBound(HtmlFile)
        If HtmlFile(lngF).Name = "" Then Exit For
    
        ' t@CɊւ탊N񐔃`FbNB
        If HtmlFile(lngF).Linked = 0 And CheckSet(lnggSetId).AlertIgnoredFile > 0 Then
            Call AddCheckComment(HtmlFile(lngF).Comment(), _
                                 10, "̃t@ĆAǂNĂ܂B")
        End If
    
        ' eAJ[Ɋւ탊N񐔃`FbNB
        For lngH = LBound(HtmlFile(lngF).Anchor) To UBound(HtmlFile(lngF).Anchor)
            If HtmlFile(lngF).Anchor(lngH).TagId < 0 Then Exit For
        
            ' 탊N񐔂 0 Ȃ΁A
            If HtmlFile(lngF).Anchor(lngH).Linked = 0 Then
            
                lngT = HtmlFile(lngF).Anchor(lngH).TagId
                lngA = HtmlFile(lngF).Anchor(lngH).AttribId
                strName = HtmlFile(lngF).Tag(lngT).Attrib(lngA).Name
                strValue = AoyeHtml.TrimQuote(HtmlFile(lngF).Tag(lngT).Attrib(lngA).Value)
                
                ' AJ[Lq󕶎łȂȂ΁A
                If strValue <> "" Then
                    If (strName Like "[Nn][Aa][Mm][Ee]" And _
                            CheckSet(lnggSetId).AlertIgnoredNameAnchor > 0) Or _
                       (strName Like "[Ii][Dd]" And _
                            CheckSet(lnggSetId).AlertIgnoredIdAnchor > 0) Then
                        Call AddCheckComment( _
                                 HtmlFile(lngF).Tag(lngT).Attrib(lngA).Comment(), _
                                 530, "̃AJ[́AǂNĂ܂B")
                    End If
                End If
                
            End If
        
        Next lngH
    
    Next lngF
    
    AnalyzeLinkedStatus = 0

    Exit Function
    
ErrorHandler:
    AnalyzeLinkedStatus = 1

End Function


'=====================================================================
' pXLq󂯎A"\" ̎gɌ肪`FbNB
' pXLq "\" ܂܂Ă邱ƂOƂB
'---------------------------------------------------------------------
'  : strTarget : Ώۂ̃pXLqB
'---------------------------------------------------------------------
' ߂l : 0 : pXLqɖ͌ȂB
'          1 : "\" gp֎~ɂ炸gĂB
'          2 : "\" ͋Ă邪A"\"  "/" ݂ĂB
'          G[Nꍇ͂ 0 ԂBi̊֐Ăяo
'          ōNȂ߁j
'---------------------------------------------------------------------
' Note : "file:/C:\windows\notepad.exe" ƂLq "\"  "/" ݂邪A
'        NN2`4, IE2`4 ŋ̂ŁÃP[XɌu݁vƂ͂ȂB
'---------------------------------------------------------------------
Private Function CheckSlash( _
    strTarget As String) As Byte

    On Error GoTo ErrorHandler

    ' "\" gp֎~Ȃ΁A߂l 1
    If CheckSet(lnggSetId).AllowBackSlash = 0 Then
        CheckSlash = 1
    ' "/" ݂Ȃ΁A
    ElseIf InStr(1, strTarget, "/", 0) > 0 Then
        ' 擪 "file:/" Ȃ΁A
        If strTarget Like "[Ff][Ii][Ll][Ee]:/*" Then
            ' ȍ~ōŏ "/" ȊOoʒu (P) 擾AP 炠Ƃ
            ' ɂǂ "/" oȂ΁A݂Ƃ݂ȂĂ悢B
            ' ȂȂ΁AP 炠Ƃ "\" o邱Ƃ͊֐ĂяȏO
            ' ܂܂邩炾B
            If InStr(AoyeText.InStrCont(6, strTarget, "/", 0), strTarget, "/", 0) > 0 Then
                CheckSlash = 2
            Else
                CheckSlash = 0
            End If
        Else  ' 擪 "file:/" łȂȂ΁AŖ߂l 2
            CheckSlash = 2
        End If
    End If

    Exit Function
    
ErrorHandler:
    CheckSlash = 0

End Function


'=====================================================================
' [~] {^ꂽۂ́AmF_CAOB
'---------------------------------------------------------------------
' ߂l : True  : mF_CAO [OK] ꂽBi܂A𒆒fj
'          False : mF_CAO [Cancel] ꂽBi܂A𑱍sj
'---------------------------------------------------------------------
Public Function ConfirmCancel() As Boolean

    On Error GoTo ErrorHandler
    
    ConfirmCancel = True  ' ftHg̖߂l True ɂB

    If boolgExecuting Then  ' [~] {^ĂȂȂ΁A
        ConfirmCancel = False  ' sB
    
    Else  ' [~] {^ꂽꍇA
        ' {ɒfĂ悢AmFB
        If MsgBox("𒆒f܂B낵łH", _
                  vbYesNo + vbQuestion + vbDefaultButton2, _
                  "̒f") = vbYes Then  ' [͂] ꂽȂ΁A
            'If boolgLogFileEnabled Then  ' iKvȂ΁jfꂽƂOɋLqB
            '    Call AoyeFileIo.WriteTextFile( _
            '             strgLogFilePath, _
            '             "irŒ~܂j" & vbCrLf & vbCrLf, 0, 1)
            'End If
            ConfirmCancel = True  ' True ߂lƂĕԂB
        Else  ' [] ꂽȂ΁A
            boolgExecuting = True  ' tOɖ߂
            ConfirmCancel = False  ' False ߂lƂĕԂBi= sj
        End If
    
    End If

ErrorHandler:

End Function


'=====================================================================
' HtmlFileStructure \̂󂯎AHTML t@CȂ΃^OLq̒oE͂sȂA
' ei[B
'---------------------------------------------------------------------
'  : TargetFile : ΏۂƂȂ\́B
'                     Name ô݊ɃZbgς݂ƂB
'        strHtmlFilePatternL() : t@C HTML t@Ĉł邩ǂ𔻒肷
'                                ߂ɎgAt@Cp^[B
'                                Like Zp̃p^[ɂȂĂ邱ƁB
'                                ʂɁA"*.*htm*" ƂvfĂB
'---------------------------------------------------------------------
' ߂l : TargetFile.Status Ɋi[ꂽlB
'---------------------------------------------------------------------
Public Function ConstructHtmlFileStructure( _
    TargetFile As HtmlFileStructure, strHtmlFilePatternL() As String) As Byte

    On Error GoTo ErrorHandler

    Dim lngT As Long
    Dim lngA As Long
    Dim lngI As Long  ' [vpJE^
    Dim lngJ As Long  ' [vpJE^
    Dim lngK As Long  ' [vpJE^
    Dim lngL As Long  ' ^O LinkTag() ẑǂ index ɑ邩B
    
    Dim strAttrName As String
    Dim strEqual As String
    Dim strAttrValue As String
    
    Dim strHtml As String  ' HTML t@C̓eŜobt@B
    
    ' HTML ̐؂蕪vfzB^OLq邱ƂB
    Dim strTag() As String:  ReDim strTag(0 To 0)
    Dim strAttrib() As String:  ReDim strAttrib(0 To 0)
    Dim strTagName As String
    
    Dim lngLineT As Long:  lngLineT = 1 ' ̃^ŐLqJnsB
    Dim lngLineA As Long                ' ̑Lq̋LqJnsB
    
    Dim strBaseUrl As String
    Dim strMessage As String
    
    Dim boolIdExists As Boolean   ' id ܂܂ĂiȂjƂtO
    Dim boolRegisteredTag As Boolean  ' Ώۂ̃^OłiȂjƂtO
    Dim boolTargetAttrib As Boolean  ' ̗p鑮ł邩ǂ̃tOB

    '------------------------------

    ' vfɎgĂzB
    ReDim TargetFile.Anchor(0 To 0)
    ReDim TargetFile.Tag(0 To 0)
    ReDim TargetFile.Comment(0 To 0)
    
    TargetFile.Anchor(0).TagId = -1

    '------------------------------

    ' HTML t@CƂĈ̂ǂ𔻒肷B
    ' HTML t@CłȂȂ΁A
    If Not ValidFileNamePattern(TargetFile.Name, strHtmlFilePatternL()) Then
        TargetFile.Status = 1  ' ֐𔲂B
        ConstructHtmlFileStructure = TargetFile.Status
        Exit Function
    End If

    ' HTML t@CȂ΁A
    ' SJIS ɕϊŃt@CǂݍށB
    ' EUC ͂ƂAJIS ̏ꍇ̓^OLq 2 oCgƂ
    ' \邩ȂĤŁAZbgϊKvƎvB
    If AoyeCharSet.ReadTextFileC(TargetFile.Name, strHtml) > 3 Then
        TargetFile.Status = 2
        strMessage = "t@C̓ǂݍ݂Ɏs܂B"
        GoTo ErrorHandler  ' G[NA߂lݒ肵Ċ֐𔲂B
    End If
   
    '------------------------------

    ' ^OLqƔ^OLqƂɐ؂蕪
    If AoyeHtml.SplitHtml(strHtml, strTag()) = 0 Then
        TargetFile.Status = 3
        strMessage = "HTML ^O̐؂oɎs܂B"
        GoTo ErrorHandler  ' G[NA߂lݒ肵Ċ֐𔲂B
    Else
        TargetFile.Status = 0  ' ؂oɐꍇB
    End If

    ' ؂蕪ꂽvf̂AΏۂƂȂ^OLq݂̂I蕪ďB
    For lngI = LBound(strTag) To UBound(strTag)
        
        boolIdExists = False
        boolRegisteredTag = False
        
        ' id ܂łi炵jȂ΁AtO𗧂ĂB
        If strTag(lngI) Like strgIdL Then boolIdExists = True
        
        ' ^ÖꕶڂAJn^OƂȂ蓾Ȃ΁A
        ' iԒZk̂߁AĂ If i܂B
        '   strTag() ̑Svfɂ GetTagName() ֐ĂяoρBj
        If Left$(strTag(lngI), 2) Like strgLinkTagHeads Then
            ' ^O擾B
            strTagName = AoyeHtml.GetTagName(strTag(lngI))
            ' ̃^OALinkTag() ɓo^Ă^OȂ̂ǂAׂB
            ' strgLinkTagName() ̊evf͔pAt@xbgł邱Ƃ
            ' ۏ؂Ăiڍׂ IntialiseLinkTag() ֐QƁjA
            ' ɑ΂ăoCir̂ŁA
            ' AoyeHtml.LCaseEn() łȂALCase ŕό`č\ȂB
            lngL = AoyeText.BinarySearch( _
                       strgLinkTagName(), LCase$(strTagName), _
                       LBound(strgLinkTagName), UBound(strgLinkTagName), 0)
                ' LinkTag() ɓo^Ă^OȂ΁AtO𗧂ĂB
                If lngL >= LBound(strgLinkTagName) Then boolRegisteredTag = True
        End If
        
        ' id ܂łi炵jA邢 LinkTag() ɓo^Ă^OȂ΁A
        If boolIdExists Or boolRegisteredTag Then  '  (A) 
        
            ' ܂AAoyeHtml.SplitTag() ֐ŁA^OLq؂蕪B
            ' G[NꍇÃ^O͖B
            ReDim strAttrib(0 To 0)
            If AoyeHtml.SplitTag(strTag(lngI), strAttrib()) > 0 Then  '  (B) 
            
                ' boolRegisteredTag Ȕꍇi܂ id 炵AƂ
                ' ܂ŗĂꍇjA{ id ݂邩`FbNB
                If Not boolRegisteredTag Then
                    ' ؂蕪ꂽvfꂼɂāA
                    ' iŏ 3 vf͖Ă悢B : "<", "a", " ", "href=...", ...j
                    For lngJ = LBound(strAttrib()) + 3 To UBound(strAttrib())
                        ' id ̊JnLqƂ݂ȂȂ΁AFor [v𔲂B
                        If strAttrib(lngJ) Like strgIdStartL Then
                            Exit For
                        End If
                    Next lngJ
                    '  For [v肫Aid ȂƂB
                    If lngJ > UBound(strAttrib()) Then
                        ' s̃CNgāA
                        lngLineT = lngLineT + AoyeText.CountNewLineCode(strTag(lngI))
                        GoTo LoopI_End  ' continue B
                    ' ۂ id A^O擾B
                    Else
                        strTagName = AoyeHtml.GetTagName(strTag(lngI))
                    End If
                End If
            
                ' ܂ŗm id A邢
                ' mɏΏۂ̃^OłAƂƂm肵B
                
                ' A<meta> ^O http-equiv="refresh" ꍇ͖
                ' continue B
                If strAttrib(LBound(strAttrib) + 1) Like "[Mm][Ee][Tt][Aa]" Then
                    ' ^O̊e؂蕪ʂɂāA
                    For lngJ = LBound(strAttrib) + 3 To UBound(strAttrib)
                        ' 擪 http-equiv Ȃ΁A
                        If InStr(1, strAttrib(lngJ), "http-equiv", 1) = 1 Then
                            ' Ƒl؂蕪B
                            If AoyeHtml.SplitAttribute(strAttrib(lngJ), _
                                   strAttrName, strEqual, strAttrValue) = 1 Then
                                ' l refresh Ȃ
                                If StrComp(AoyeHtml.TrimQuote(strAttrValue), _
                                           "refresh", 1) = 0 Then
                                    Exit For
                                End If
                            End If
                        End If
                    Next lngJ
                    ' ̃[v肫Arefresh ȂƂƁB
                    ' continue B
                    If lngJ > UBound(strAttrib) Then GoTo LoopI_End
                End If
                
                ' ܂ŗATag \̔z֊i[B
                
                ' ܂ATag zɂA index 擾B
                If TargetFile.Tag(UBound(TargetFile.Tag)).Name <> "" Then
                    ReDim Preserve TargetFile.Tag(0 To UBound(TargetFile.Tag) + 1)
                End If
                lngT = UBound(TargetFile.Tag)
                ReDim TargetFile.Tag(lngT).Attrib(0 To 0)
                
                ' lKpB
                TargetFile.Tag(lngT).Name = strTagName
                TargetFile.Tag(lngT).Line = lngLineT
                ReDim TargetFile.Tag(lngT).Comment(0 To 0)
                ' ^ÓAstrgLinkTagName ɂ index ԍB
                If boolRegisteredTag Then
                    TargetFile.Tag(lngT).Id = lngL
                Else  ' strgLinkTagName ɂ͂ȂAid ĂƂꍇ́A
                    TargetFile.Tag(lngT).Id = -1  ' ֋XI -1 ZbgB
                End If
            
                '  3 vfi^ÕXy[Xj̉sZčsB
                lngLineA = lngLineT + _
                           AoyeText.CountNewLineCode(strAttrib(LBound(strAttrib) + 2))
            
                ' ؂蕪ꂽvfꂼɂāA
                ' iŏ 3 vf͖Ă悢B : "<", "a", " ", "href=...", ...j
                For lngJ = LBound(strAttrib()) + 3 To UBound(strAttrib())
                
                    ' LqAOƒlɐ؂蕪BLqƂ݂ȂȂ΁A
                    If AoyeHtml.SplitAttribute(strAttrib(lngJ), _
                                               strAttrName, strEqual, _
                                               strAttrValue) = 1 Then  '  (C) 
                        ' id ̏ꍇ
                        If strAttrName Like "[Ii][Dd]" Then
                            boolTargetAttrib = True
                        ' id łȂAo^Ă^OȂ΁A
                        ElseIf boolRegisteredTag Then
                            ' ̑Ã^O郊N摮ł邩B
                            For lngK = LBound(LinkTag(lngL).Attrib) To _
                                       UBound(LinkTag(lngL).Attrib)
                                If StrComp(LinkTag(lngL).Attrib(lngK).Name, _
                                           LCase$(strAttrName), 0) = 0 Then Exit For
                            Next lngK
                            If lngK <= UBound(LinkTag(lngL).Attrib) Then
                                boolTargetAttrib = True
                            Else
                                boolTargetAttrib = False
                            End If
                        Else  ' id łȂAo^Ă^OłȂȂ΁A
                            boolTargetAttrib = False
                        End If
                        
                        ' id łA邢
                        ' ̃^O郊N摮Ȃ΁A
                        If boolTargetAttrib Then  '  (D) 
                        
                            ' Attrib() z֒ǉB
                            ' ܂́Af[^̍ݐ index  lngA Ɋi[A
                            If TargetFile.Tag(lngT).Attrib( _
                                   UBound(TargetFile.Tag(lngT).Attrib)).Name _
                               <> "" Then
                                ReDim Preserve TargetFile.Tag(lngT).Attrib( _
                                   UBound(TargetFile.Tag(lngT).Attrib) + 1)
                            End If
                            lngA = UBound(TargetFile.Tag(lngT).Attrib)
                            ReDim TargetFile.Tag(lngT).Attrib(lngA).Comment(0 To 0)
                    
                            ' elZbgB
                            TargetFile.Tag(lngT).Attrib(lngA).Name = strAttrName
                            TargetFile.Tag(lngT).Attrib(lngA).Value = strAttrValue
                            
                             ' RealLine óAɑl̍s̗pB
                            TargetFile.Tag(lngT).Attrib(lngA).RealLine = _
                                lngLineA + AoyeText.CountNewLineCode(strEqual)
                            
                            ' sԍ̓IvVɉāA̗plςB
                            Select Case bytgLineOption
                                Case 0  ' ^O̐擪̗pꍇ
                                    TargetFile.Tag(lngT).Attrib(lngA).Line = lngLineT
                                Case 1  ' ̗pꍇ
                                    TargetFile.Tag(lngT).Attrib(lngA).Line = lngLineA
                                Case 2  ' l̗pꍇ
                                    TargetFile.Tag(lngT).Attrib(lngA).Line = _
                                        TargetFile.Tag(lngT).Attrib(lngA).RealLine
                            End Select
                            
                        End If  '  (D) 
                        
                    End If  '  (C) 
                
                    '  index ̉sŃCNg
                    lngLineA = lngLineA + AoyeText.CountNewLineCode(strAttrib(lngJ))
                
                Next lngJ
            
            End If  '  (B) 
        End If  '  (A) 
        
        ' ^Oł낤ƂȂ낤ƁAs͖CNgB
        lngLineT = lngLineT + AoyeText.CountNewLineCode(strTag(lngI))
    
LoopI_End:
    Next lngI

    ConstructHtmlFileStructure = TargetFile.Status

    Exit Function

ErrorHandler:
    If TargetFile.Status = 0 Then
        TargetFile.Status = 99
        strMessage = "HTML \̉͒ɖm̃G[N܂B"
    End If
    Call AddCheckComment(TargetFile.Comment(), TargetFile.Status, strMessage)
    ConstructHtmlFileStructure = TargetFile.Status

End Function


'=====================================================================
' IȌx ID AOLqp ID ֕ϊB
'---------------------------------------------------------------------
'  : bytLevel : xxB 1 = file, 2 = tag, 3 = attribute
'        lngInId : IȌx ID
'---------------------------------------------------------------------
' ߂l : OLqp ID
'---------------------------------------------------------------------
Public Function ConvertAlertId( _
    bytLevel As Byte, lngInId As Long) As Byte

    On Error GoTo ErrorHandler
    
    Select Case bytLevel
        '---------------
        ' t@C
        Case 1
            Select Case lngInId
                Case 2:    ConvertAlertId = 1
                Case 3:    ConvertAlertId = 2
                Case 10:   ConvertAlertId = 3
                Case 99:   ConvertAlertId = 9
                Case Else: ConvertAlertId = 99
            End Select
        '---------------
        ' ^O
        Case 2
            Select Case lngInId
                Case 1:    ConvertAlertId = 11
                Case 2:    ConvertAlertId = 12
                Case 4:    ConvertAlertId = 13
                Case 5:    ConvertAlertId = 14
                Case 99:   ConvertAlertId = 19
                Case Else: ConvertAlertId = 99
            End Select
        '---------------
        ' l
        Case Else
            Select Case lngInId
                Case 308:  ConvertAlertId = 21
                Case 906:  ConvertAlertId = 21
                Case 302:  ConvertAlertId = 22
                Case 901:  ConvertAlertId = 22
                Case 303:  ConvertAlertId = 23
                Case 902:  ConvertAlertId = 23
                Case 907:  ConvertAlertId = 24
                Case 903:  ConvertAlertId = 25
                Case 904:  ConvertAlertId = 26
                Case 905:  ConvertAlertId = 27
                Case 301:  ConvertAlertId = 31
                Case 1:    ConvertAlertId = 31
                Case 102:  ConvertAlertId = 32
                Case 2:    ConvertAlertId = 32
                Case 304:  ConvertAlertId = 33
                Case 305:  ConvertAlertId = 34
                Case 306:  ConvertAlertId = 35
                Case 307:  ConvertAlertId = 36
                Case 909:  ConvertAlertId = 37
                Case 10:   ConvertAlertId = 41
                Case 11:   ConvertAlertId = 42
                Case 12:   ConvertAlertId = 43
                Case 13:   ConvertAlertId = 44
                Case 14:   ConvertAlertId = 45
                Case 15:   ConvertAlertId = 46
                Case 16:   ConvertAlertId = 47
                Case 17:   ConvertAlertId = 48
                Case 18:   ConvertAlertId = 49
                Case 19:   ConvertAlertId = 50
                Case 20:   ConvertAlertId = 51
                Case 21:   ConvertAlertId = 52
                Case 22:   ConvertAlertId = 53
                Case 202:  ConvertAlertId = 56
                Case 203:  ConvertAlertId = 57
                Case 501:  ConvertAlertId = 61
                Case 502:  ConvertAlertId = 61
                Case 510:  ConvertAlertId = 62
                Case 520:  ConvertAlertId = 63
                Case 530:  ConvertAlertId = 64
                Case 908:  ConvertAlertId = 96
                Case 99:   ConvertAlertId = 97
                Case 399:  ConvertAlertId = 98
                Case 999:  ConvertAlertId = 98
                Case Else: ConvertAlertId = 99
            End Select
    End Select
    
    Exit Function
    
ErrorHandler:
    ConvertAlertId = 99

End Function


'=====================================================================
' pXLq󂯎Ã^Cv𔻒肷B
'---------------------------------------------------------------------
'  : strTarget : ΏۂƂȂpXLq
'---------------------------------------------------------------------
' ߂l : 1 : [J̃tpXLqi"file:" vgRLqȂj
'                   : "C:\windows\notepad.exe"
'          2 : [J̃tpXLqi"file:" vgRLqj
'                   : "file:///C|/windows/notepad.exe"
'          3 : vgRtpXLqi"//" j
'                   : "http://www.yahoo.com/index.htm"
'          4 : ΃pXLqi` "/"  "\" j
'                   : "/hoge/foo.txt"
'          5 : ΃pXLqi` "/"  "\" Ȃj
'                   : "hoge/foo.txt"
'          6 : vgRLqi"//" Ȃj
'                   : "mailto:hoge@foo.com"
'          7 : 󕶎B邢́A"file://" ƂɁA̋B
'          0 : sȋLqA邢͏G[
'---------------------------------------------------------------------
Public Function DetectPathType( _
    strTarget As String) As Byte

    On Error GoTo ErrorHandler
    
    Dim lngColon As Long
    Dim lngNotSlash As Long
    Dim lngReturnValue As Long
    Dim strBuffer As String
    
    If strTarget = "" Then  ' 󕶎̏ꍇ
        DetectPathType = 7

    ElseIf strTarget Like "[A-Za-z][:|]*" Then  ' 擪񕶎hCu炵Ȃ΁A
        If Len(strTarget) = 2 Or Mid$(strTarget, 3, 1) Like "[\/]" Then
            DetectPathType = 1
        Else
            DetectPathType = 0
        End If
    
    ElseIf strTarget Like "[\/][\/][A-Za-z]*" Then  ' 擪O Network Computer Ȃ
        DetectPathType = 1
    
    Else
        lngColon = InStr(1, strTarget, ":", 0)  ' ":" ̏oʒu擾B
    
        If lngColon = 0 Then  ' ":" ݂ȂȂ΁A
            ' vgRȂƔfĂ悢B
            If strTarget Like "[\/]*" Then  ' ꕶڂfBNg؂LȂ
                DetectPathType = 4
            Else
                DetectPathType = 5
            End If
        
        Else  ' ":" ݂Ȃ΁AvgR̉\lB
        
            ' ":" ܂ŔpAt@xbgȊOĂȂ΁A
            If Left$(strTarget, lngColon - 1) Like "*[!A-Za-z]*" Then
                DetectPathType = 0  ' sȋLqƂ݂ȂB
                
            ' SpAt@xbgȂ΁AvgRƂ݂ȂB
            Else
                '  "/" ȊOoʒu擾B
                lngNotSlash = AoyeText.InStrCont(lngColon + 1, strTarget, "/", 0)
            
                If strTarget Like "[Ff][Ii][Ll][Ee]:*" Then  ' FILE vgRȂ΁A
                    ' "/" A͎Ooꍇ́A
                    If lngNotSlash = 7 Or lngNotSlash = 9 Then
                        strBuffer = Mid$(strTarget, lngNotSlash)
                        
                        ' "/" ̒オ[JtpXLq̖`Ƃ݂ȂȂ΁A
                        If strBuffer Like "[A-Za-z][:|]*" Or _
                           strBuffer Like "[\/][\/][A-Za-z]*" Then
                            Select Case DetectPathType(strBuffer)  ' ċAĂяoB
                                Case 1:  DetectPathType = 2  ' [JtpX
                                Case 7:  DetectPathType = 7  ' e
                                Case Else:  DetectPathType = 0  ' G[
                            End Select
                        Else  ' [JtpX̖`Ƃ݂ȂȂȂ΁A
                            DetectPathType = 0
                        End If
                    
                    Else  ' "/" ̉񐔂Ȃꍇ́A
                        DetectPathType = 0  ' sȋLqƂ݂ȂB
                    End If
                    
                Else  ' FILE vgRȊOȂ΁A
                    ' vgR "/" ̌ŏB
                    Select Case lngNotSlash - lngColon - 1
                        Case 2:  DetectPathType = 3
                        Case 0:  DetectPathType = 6
                        Case Else:  DetectPathType = 0
                    End Select
                End If
            End If
        End If
    End If
    
    Exit Function
    
ErrorHandler:
    DetectPathType = 0

End Function


'=====================================================================
' DOS ChJ[hLq̔z󂯎ALike ZpChJ[hLq֕ϊ
' ʔz֎߂B
'---------------------------------------------------------------------
'  : strLikeWc() : Like ZpChJ[hLq̔zi߂lj
'        strDosWc()  : DOS ChJ[hLq̔z
'---------------------------------------------------------------------
' ߂l : 0 : I
'          1 : G[I
'---------------------------------------------------------------------
Public Function DosWcToLikeWcArray( _
    strLikeWc() As String, strDosWc() As String) As Byte

    On Error GoTo ErrorHandler
    
    Dim lngI As Long

    ReDim strLikeWc(LBound(strDosWc) To UBound(strDosWc))
    For lngI = LBound(strDosWc) To UBound(strDosWc)
        strLikeWc(lngI) = AoyeFileList.DosWcToLikeWc(strDosWc(lngI))
    Next lngI

    DosWcToLikeWcArray = 0

    Exit Function
    
ErrorHandler:
    DosWcToLikeWcArray = 1

End Function


'=====================================================================
' LinkTag() B
'---------------------------------------------------------------------
Public Sub InitializeLinkTag()

    Dim lngI As Long:  lngI = 0

    '  evf Name ɊւāAɏ\[gƂȂ悤ɋLqB
    '    VKɗvfǉꍇ́AmȈʒu֑}邱ƁB
    '    Attrib(#).Name ɊւẮAɏԂ͖ȂB
    '  ܂ Name vfAAttrib(#).Name vf̒ĺA
    '    pAt@xbgłȂĂ͂ȂȂB

    ReDim LinkTag(0 To 0)
    LinkTag(0).Name = "a"
    ReDim LinkTag(0).Attrib(0 To 1)  '  ̏́AɉďB
    LinkTag(0).Attrib(0).Name = "href"
    LinkTag(0).Attrib(0).Required = False
    LinkTag(0).Attrib(1).Name = "name"
    LinkTag(0).Attrib(1).Required = False
    ' href  ͂P̂ƂĂ͕K{łȂ̂ False ƂB
    '  name, id Ăꍇ́AG[ƂČxKvB
    
    lngI = lngI + 1:  ReDim Preserve LinkTag(0 To lngI)
    LinkTag(lngI).Name = "applet"
    ReDim LinkTag(lngI).Attrib(0 To 0)  '  codebase ɑΉAύXB
    LinkTag(lngI).Attrib(0).Name = "code"
    LinkTag(lngI).Attrib(0).Required = True
    'LinkTag(lngI).Attrib(1).Name = "codebase"
    'LinkTag(lngI).Attrib(1).Required = False

    lngI = lngI + 1:  ReDim Preserve LinkTag(0 To lngI)
    LinkTag(lngI).Name = "area"
    ReDim LinkTag(lngI).Attrib(0 To 0)
    LinkTag(lngI).Attrib(0).Name = "href"
    LinkTag(lngI).Attrib(0).Required = True

    ' <base> ^OŏΏۂƂȂ鑮 href iK{ĵ݂ƂB
    ' ̑OύXꍇ́AAnalyzeHtmlFileStructure() ֐
    ' o <base> ^ÖɊւZNVKvB
    lngI = lngI + 1:  ReDim Preserve LinkTag(0 To lngI)
    LinkTag(lngI).Name = "base"
    ReDim LinkTag(lngI).Attrib(0 To 0)
    LinkTag(lngI).Attrib(0).Name = "href"
    LinkTag(lngI).Attrib(0).Required = False

    lngI = lngI + 1:  ReDim Preserve LinkTag(0 To lngI)
    LinkTag(lngI).Name = "bgsound"
    ReDim LinkTag(lngI).Attrib(0 To 0)
    LinkTag(lngI).Attrib(0).Name = "src"
    LinkTag(lngI).Attrib(0).Required = True

    lngI = lngI + 1:  ReDim Preserve LinkTag(0 To lngI)
    LinkTag(lngI).Name = "body"
    ReDim LinkTag(lngI).Attrib(0 To 0)
    LinkTag(lngI).Attrib(0).Name = "background"
    LinkTag(lngI).Attrib(0).Required = False

    lngI = lngI + 1:  ReDim Preserve LinkTag(0 To lngI)
    LinkTag(lngI).Name = "embed"
    ReDim LinkTag(lngI).Attrib(0 To 0)
    LinkTag(lngI).Attrib(0).Name = "src"
    LinkTag(lngI).Attrib(0).Required = True

    lngI = lngI + 1:  ReDim Preserve LinkTag(0 To lngI)
    LinkTag(lngI).Name = "form"
    ReDim LinkTag(lngI).Attrib(0 To 0)
    LinkTag(lngI).Attrib(0).Name = "action"
    LinkTag(lngI).Attrib(0).Required = False
    ' CGI փf[^Mꍇ action ͕K{AJavaScript ̃f[^o
    ' vfƂătH[igꍇ́AK action ͕KvłȂB
    ' āARequired  False ƂB

    lngI = lngI + 1:  ReDim Preserve LinkTag(0 To lngI)
    LinkTag(lngI).Name = "frame"
    ReDim LinkTag(lngI).Attrib(0 To 0)
    LinkTag(lngI).Attrib(0).Name = "src"
    LinkTag(lngI).Attrib(0).Required = True

    lngI = lngI + 1:  ReDim Preserve LinkTag(0 To lngI)
    LinkTag(lngI).Name = "iframe"
    ReDim LinkTag(lngI).Attrib(0 To 0)
    LinkTag(lngI).Attrib(0).Name = "src"
    LinkTag(lngI).Attrib(0).Required = True

    lngI = lngI + 1:  ReDim Preserve LinkTag(0 To lngI)
    LinkTag(lngI).Name = "ilayer"
    ReDim LinkTag(lngI).Attrib(0 To 0)
    LinkTag(lngI).Attrib(0).Name = "src"
    LinkTag(lngI).Attrib(0).Required = False

    lngI = lngI + 1:  ReDim Preserve LinkTag(0 To lngI)
    LinkTag(lngI).Name = "img"
    ReDim LinkTag(lngI).Attrib(0 To 1)
    LinkTag(lngI).Attrib(0).Name = "src"
    LinkTag(lngI).Attrib(0).Required = True
    LinkTag(lngI).Attrib(1).Name = "lowsrc"
    LinkTag(lngI).Attrib(1).Required = False

    lngI = lngI + 1:  ReDim Preserve LinkTag(0 To lngI)
    LinkTag(lngI).Name = "layer"
    ReDim LinkTag(lngI).Attrib(0 To 0)
    LinkTag(lngI).Attrib(0).Name = "src"
    LinkTag(lngI).Attrib(0).Required = False

    lngI = lngI + 1:  ReDim Preserve LinkTag(0 To lngI)
    LinkTag(lngI).Name = "link"
    ReDim LinkTag(lngI).Attrib(0 To 2)
    LinkTag(lngI).Attrib(0).Name = "href"
    LinkTag(lngI).Attrib(0).Required = False
    LinkTag(lngI).Attrib(1).Name = "src"
    LinkTag(lngI).Attrib(1).Required = False
    LinkTag(lngI).Attrib(2).Name = "rev"
    LinkTag(lngI).Attrib(2).Required = False

    lngI = lngI + 1:  ReDim Preserve LinkTag(0 To lngI)
    LinkTag(lngI).Name = "meta"
    ReDim LinkTag(lngI).Attrib(0 To 0)
    LinkTag(lngI).Attrib(0).Name = "content"
    LinkTag(lngI).Attrib(0).Required = True
    ' ΏۂƂȂ <meta> ^O͕K refresh gĂƂOBႦ΁A
    ' <meta http-equiv="refresh" content="10;url=http://www.nowhere.com/">
    ' ̑OύXꍇ́AConstructHtmlFileStructure() ֐A
    ' VerifyLinkAttribute() ֐ύXKvB

    lngI = lngI + 1:  ReDim Preserve LinkTag(0 To lngI)
    LinkTag(lngI).Name = "object"
    ReDim LinkTag(lngI).Attrib(0 To 0)
    LinkTag(lngI).Attrib(0).Name = "data"
    LinkTag(lngI).Attrib(0).Required = True

    lngI = lngI + 1:  ReDim Preserve LinkTag(0 To lngI)
    LinkTag(lngI).Name = "script"
    ReDim LinkTag(lngI).Attrib(0 To 0)
    LinkTag(lngI).Attrib(0).Name = "src"
    LinkTag(lngI).Attrib(0).Required = False

    lngI = lngI + 1:  ReDim Preserve LinkTag(0 To lngI)
    LinkTag(lngI).Name = "style"
    ReDim LinkTag(lngI).Attrib(0 To 0)
    LinkTag(lngI).Attrib(0).Name = "src"
    LinkTag(lngI).Attrib(0).Required = False

    lngI = lngI + 1:  ReDim Preserve LinkTag(0 To lngI)
    LinkTag(lngI).Name = "table"
    ReDim LinkTag(lngI).Attrib(0 To 0)
    LinkTag(lngI).Attrib(0).Name = "background"
    LinkTag(lngI).Attrib(0).Required = False

    lngI = lngI + 1:  ReDim Preserve LinkTag(0 To lngI)
    LinkTag(lngI).Name = "td"
    ReDim LinkTag(lngI).Attrib(0 To 0)
    LinkTag(lngI).Attrib(0).Name = "background"
    LinkTag(lngI).Attrib(0).Required = False

    lngI = lngI + 1:  ReDim Preserve LinkTag(0 To lngI)
    LinkTag(lngI).Name = "th"
    ReDim LinkTag(lngI).Attrib(0 To 0)
    LinkTag(lngI).Attrib(0).Name = "background"
    LinkTag(lngI).Attrib(0).Required = False

    lngI = lngI + 1:  ReDim Preserve LinkTag(0 To lngI)
    LinkTag(lngI).Name = "tr"
    ReDim LinkTag(lngI).Attrib(0 To 0)
    LinkTag(lngI).Attrib(0).Name = "background"
    LinkTag(lngI).Attrib(0).Required = False

    '-----------------------

    ' LinkTag() z Name vfɂĂ̂݁ALinkTagName() zփRs[B
    ReDim strgLinkTagName(0 To UBound(LinkTag))

    For lngI = 0 To UBound(LinkTag)
        strgLinkTagName(lngI) = LinkTag(lngI).Name
    Next lngI

    '-----------------------

    strgLinkTagHeads = "<[" & JoinTopLetter(strgLinkTagName) & "]"

End Sub


'=====================================================================
' *tpXLq* 󂯎Aꂪ[J̃pXiDOS `jł邩ǂ𔻒肷B
' lbg[NERs[^gLq[JɂȂ_ɒӁB
'---------------------------------------------------------------------
'  : strTarget : Ώۂ̃pXLqBtpXł邱ƂOƂB
'---------------------------------------------------------------------
' ߂l : True : [J̃tpXłƉ߂łB
'          False : [J̃tpXƂ͉߂łȂB邢́AG[NB
'---------------------------------------------------------------------
' gp : "C:\windows\notepad.exe"  True
'          "\\hoge\foo"  True
'          "..\sample.txt"  False
'          "http://www.yahoo.com/index.htm"  False
'---------------------------------------------------------------------
Private Function IsLocalPath( _
    strTarget As String) As Boolean

    On Error GoTo ErrorHandler
    
    If strTarget Like "[A-Za-z]:*" Or strTarget Like "\\[A-Za-z]*" Then
        IsLocalPath = True
    Else
        IsLocalPath = False
    End If

    Exit Function
    
ErrorHandler:
    IsLocalPath = False

End Function


'=====================================================================
' 󂯎Aꂪ[AhXLqƂ݂Ȃ邩肷B
'---------------------------------------------------------------------
'  : strTarget : ؑΏۂ̕
'        varStrict : 0 : hCɑSp܂܂꓾B ftHgl
'                    1 : hCɂ͔pp "-" ȊO܂܂꓾ȂB
'---------------------------------------------------------------------
' ߂l : True  : strTarget ̓[AhXƂ݂Ȃ
'          False : strTarget ̓[AhXƂ݂ȂȂB
'---------------------------------------------------------------------
Private Function IsMailAddress( _
    ByVal strTarget As String, Optional varStrict As Variant) As Boolean

    On Error GoTo ErrorHandler

    IsMailAddress = False

    Dim lngAtMark As Long
    Dim lngQuestion As Long
       
    lngAtMark = InStr(1, strTarget, "@", 0)
    If lngAtMark > 0 Then  ' "@" ܂܂Ȃ΁A
        lngQuestion = InStr(1, strTarget, "?", 0)
        If InStr(1, strTarget, "?", 0) > 0 Then  ' "?" ܂܂Ȃ΁A
            ' ȍ~؂藎ƂB
            strTarget = Left$(strTarget, InStr(1, strTarget, "?", 0) - 1)
        End If
        ' "@" ȍ~T[oƂ݂ȂȂ
        If AoyeHtml.IsServerName(Mid$(strTarget, lngAtMark), varStrict) Then
            IsMailAddress = True
        End If
    End If
    
    Exit Function
    
ErrorHandler:
    IsMailAddress = False

End Function


'=====================================================================
' pAt@xbĝ݂ō\镶̔z󂯎A
' 擪ꕶW߂쐬Bid͂Ȃj
' InitializeLinkTag() ֐Ă΂AX[u֐B
'---------------------------------------------------------------------
'  : strArray() : Ώۂ̔zB
'                     evf́ApAt@xbgō\ĂiȂƂ
'                     擪̈ꕶ͔pAt@xbgjƂOɂB
'---------------------------------------------------------------------
' ߂l : strArray() ̊evf̐擪ꕶW߁Ad̖悤Ƀ\[gA
'          召ꂼ̃p^[ȂB
'           : ("Apple", "peach", "banana", "Lemon")  "ABLPablp"
'---------------------------------------------------------------------
Private Function JoinTopLetter(strArray() As String) As String

    On Error GoTo ErrorHandler

    Dim boolAlphabet(0 To 127) As Boolean
    Dim lngI As Long
    
    For lngI = LBound(strArray) To UBound(strArray)
        boolAlphabet(Asc(LCase$(Left$(strArray(lngI), 1)))) = True
    Next lngI
    
    For lngI = 97 To 122
        If boolAlphabet(lngI) Then
            JoinTopLetter = JoinTopLetter & Chr$(lngI)
        End If
    Next lngI
    
    JoinTopLetter = UCase$(JoinTopLetter) & JoinTopLetter

    Exit Function

ErrorHandler:
    JoinTopLetter = ""

End Function


'=====================================================================
' HtmlAttribute \̂󂯎A FullPath õN`FbNsȂB
' TargetAttrib JƂƂ͂Ȃi܂ TargetAttrib.Status = -1 ł͂ȂjA
' ܂ TargetAttrib u`FbÑ[JNvł邱ƂOɂB
'---------------------------------------------------------------------
'  : TargetAttrib : ΏۂƂȂ HtmlAttribute \
'        lngF : HtmlFile() zɂ index ԍB
'---------------------------------------------------------------------
' ߂l : 0 : I
'          1 : G[I
'---------------------------------------------------------------------
Public Function LinkCheckLocal( _
    TargetAttrib As HtmlAttribute, lngF As Long) As Byte

    On Error GoTo ErrorHandler
    
    LinkCheckLocal = 0
    
    Dim strFilePath As String
    Dim strAnchorName As String
    Dim lngFound As Long
    
    Dim strPathList() As String:  ReDim strPathList(0 To 0)
    
    Dim strMessage As String
    Dim lngI As Long
    Dim boolPathIsFile As Boolean
    Dim boolUsedDefDoc As Boolean  ' ftHghLggpǂ̃tOB
    Dim boolSharpAfterSlash As Boolean  ' "#" ̒O "/" 邢 "\" łǂB
    
    Dim lngBuffer As Long
    
    '----------------------------

    ' LqĂtpXobt@ɎoB
    strFilePath = TargetAttrib.FullPath
    
    ' "?" ꍇ́Aȍ~ CGI Ƃ݂Ȃč폜B
    lngFound = InStr(1, strFilePath, "?", 0)
    If lngFound > 0 Then
        strFilePath = Left$(strFilePath, lngFound - 1)
        If strFilePath = "" Then GoTo ErrorHandler
    End If
    
    ' "#" ܂܂Ăꍇ́A
    lngFound = InStr(1, strFilePath, "#", 0)
    If lngFound > 0 Then  ' pXƃAJ[ɐ؂蕪B
        strAnchorName = Mid$(strFilePath, lngFound + 1)
        strFilePath = Left$(strFilePath, lngFound - 1)
        ' ܂AO "\"  "/" łȂ؂B
        If lngFound > 1 Then
            If Mid$(strFilePath, lngFound - 1, 1) Like "[/\]" Then
                boolSharpAfterSlash = True
            End If
        End If
    End If
       
    ' pXAfBXNɂǂ`ő݂邩B
    Select Case AoyeFilePath.IsExistAs(strFilePath)
        Case 0  ' t@CƂĂAfBNgƂĂ݂ȂꍇB
            TargetAttrib.Status = 10
            strMessage = "Ñt@C܂B"
        Case 1  ' t@CƂđ݂ꍇ
            ' Lq̖ "\" Ăꍇ
            If Right$(strFilePath, 1) = "\" Then
                TargetAttrib.Status = 17
                strMessage = "t@C̖ɃfBNg؂LĂ܂B"
            Else
                strPathList(0) = strFilePath
                boolPathIsFile = True
            End If
        Case 2  ' fBNgƂđ݂ꍇ
            '  "\" ƂA
            If Right$(strFilePath, 1) <> "\" Then strFilePath = strFilePath & "\"
            ' ftHghLgꗗ쐬B
            For lngI = LBound(CheckSet(lnggSetId).DefaultDocument) To _
                       UBound(CheckSet(lnggSetId).DefaultDocument)
                ' ftHghLgo^ĂȂꍇA[v𔲂B
                If CheckSet(lnggSetId).DefaultDocument(lngI) = "" Then Exit For
                
                Call AoyeHtml.AddStringItem(strPathList(), _
                         strFilePath & CheckSet(lnggSetId).DefaultDocument(lngI))
                ' ftHghLggp|AtO𗧂ĂB
                boolUsedDefDoc = True
            Next lngI
    End Select
    
    ' ̎_ strMessage ݒ肳ĂȂ΁AzɒǉĊ֐𔲂B
    If strMessage <> "" Then
        Call AddCheckComment(TargetAttrib.Comment(), TargetAttrib.Status, strMessage)
        Exit Function
    End If
    
    ' strPathList() ɓepX FilePathList() ɓo^ĂȂTB
    For lngI = LBound(strPathList) To UBound(strPathList)
        ' NƂăfBNgw肳ꂽ̂ɁA
        ' ftHghLgo^ĂȂꍇ́A
        ' lngI [vI[lɃZbgA[v𔲂B
        If strPathList(lngI) = "" Then
            lngI = UBound(strPathList) + 1
            Exit For
        End If
        
        ' oCiT[` FilePathList() ̒{B
        lngFound = PathList.SearchFilePath(FilePathList(), strPathList(lngI), _
                                           LBound(FilePathList), UBound(FilePathList))
        ' AɃ[v𔲂B
        If lngFound >= LBound(FilePathList) Then Exit For
    Next lngI
    
    ' FilePathList() ̒ɃpXȂꍇ́A
    If lngI > UBound(strPathList) Then
        ' strFilePath ݂t@C̃pX̂ɁAstrPathList() ̒
        ' ȂꍇB
        If boolPathIsFile Then
            ' fBNgzɂɂ炸AFilePathList() 
            ' pXȂꍇB́At@CIvVifrmFileOptionj
            ' ̃t@C𖳎悤ݒ肳ĂꍇB
            If AoyeFileList.StrCompDos( _
                       Left$(strFilePath, Len(CheckSet(lnggSetId).LocalPath)), _
                       CheckSet(lnggSetId).LocalPath) = 0 Then
                TargetAttrib.Status = 20
                strMessage = "Nt@ĆA悤ݒ肳Ă܂B"
            ' strFilePath  CheckSet(lnggSetId).LocalPath ܂܂ȂA܂
            ' fBNg̊KwǂĂꍇB
            ' ̏ꍇAR FilePathList() ł͌ȂB
            ' "#" ܂łȂ΁A
            ElseIf InStr(1, strFilePath, "#", 0) > 0 Then
                TargetAttrib.Status = 22
                strMessage = "fBNgɂt@CȂ̂ŁA" & _
                             "AJ[̗L͌؂Ă܂B"
            Else
                TargetAttrib.Status = 91
            End If
            
            If strMessage <> "" Then
                Call AddCheckComment(TargetAttrib.Comment(), TargetAttrib.Status, strMessage)
            End If
            
        ' strFilePath ݂fBNg̃pXŁAftHg hLg
        ' Ȃ߂ɁADirectory Listing ԂƂȂꍇB
        Else
            ' Director Listing xIvVݒ肳ĂȂ΁A
            If CheckSet(lnggSetId).AlertDirListing = 1 Then
                TargetAttrib.Status = 11
                Call AddCheckComment(TargetAttrib.Comment(), _
                         TargetAttrib.Status, _
                         "ftHg hLgȂ߁A" & _
                         "fBNgQƂĂ܂B")
            End If
            
            ' AJ[LqĂȂ΁A
            If strAnchorName <> "" Then
                TargetAttrib.Status = 16
                Call AddCheckComment(TargetAttrib.Comment(), TargetAttrib.Status, _
                         "ftHg hLgfBNgɑ΂āA" & _
                         "AJ[w肵Ă܂B")
            End If
        End If
      
        Exit Function  ' ֐𔲂B
    End If
    
    ' FilePathList() ̒ɃpXȂ΁A
    
    ' ifBNgȂjTargetAttrib.FullPath ɁA
    ' pXi[Bȍ~ATargetAttrib.FullPath Ɋi[Ă̂
    ' fBNg̃pXłȂAKt@C̃pXi{AJ[jłƕۏ؂B
    TargetAttrib.FullPath = strPathList(lngI)
    If strAnchorName <> "" Then
        TargetAttrib.FullPath = TargetAttrib.FullPath & "#" & strAnchorName
    End If
    
    ' KvȂ΁At@C Case Sensitive ňv邩B
    If bytgFileNameCaseSensitive = 1 Then
        lngBuffer = Len(CheckSet(lnggSetId).LocalPath) + 1
        ' pX̕ɂāAoCiňvȂȂ΁A
        If StrComp(Mid$(strPathList(lngI), lngBuffer), _
                   Mid$(FilePathList(lngFound).Path, lngBuffer), 0) <> 0 Then
            TargetAttrib.Status = 12
            Call AddCheckComment(TargetAttrib.Comment(), TargetAttrib.Status, _
                                 "t@C̑啶^v܂B")
        End If
    End If
    
    ' NɃAJ[܂܂ĂȂȂ΁A
    If strAnchorName = "" Then
        TargetAttrib.Status = 90
        ' 탊N񐔂CNgB
        HtmlFile(FilePathList(lngFound).Index).Linked = _
                HtmlFile(FilePathList(lngFound).Index).Linked + 1
        Exit Function  ' ̎_ňꌏB֐𔲂B
    End If
    
    '---------------------------
    ' ȉANLqɃAJ[܂܂ꍇ̏B
    
    If boolUsedDefDoc Then  ' ftHghLggpĂꍇA
        ' # ̒OfBNg؂LłȂȂ΁AxΏۂƂB
        ' Ⴆ (A) http://www.myserver.com/directory#anchor ͌xΏۂƂ邪A
        '        (B) http://www.myserver.com/directory/#anchor ͌B
        ' (A)  IE4 ̏ꍇAI http://www.myserver.com/directory/index.html#anchor
        ' Ƃɓǂ݂A҂ǂɃWvsȂB NC4 ̏ꍇ
        ' index.html ɂ̓Wv邪AAJ[ʒu܂ł͈ړłȂB
        ' (B)  IE4, NC4 ƂҒʂ̃WvsȂB
        If Not boolSharpAfterSlash Then
            TargetAttrib.Status = 21
            Call AddCheckComment(TargetAttrib.Comment(), TargetAttrib.Status, _
                                 "fBNg ""#"" ̊Ԃ" & _
                                 "fBNg؂L܂B")
        End If
    End If
    
    ' Nt@C Status ɉĕ򂷂B
    Select Case HtmlFile(FilePathList(lngFound).Index).Status
        Case 1
            TargetAttrib.Status = 13
            strMessage = "N HTML t@CłȂ߁A"
        Case 2
            TargetAttrib.Status = 14
            strMessage = "Nt@C̓ǂݏoɎsĂ邽߁A"
        Case 3, 99
            TargetAttrib.Status = 15
            strMessage = "Nt@C HTML ߂ɎsĂ邽߁A"
    End Select
    
    ' ̎_ strMessage ݒ肳ĂȂ΁AzɒǉĊ֐𔲂B
    If strMessage <> "" Then
        strMessage = strMessage & "AJ[T܂B" & _
                     "it@Ĉւ̓NłĂ܂Bj"
        Call AddCheckComment(TargetAttrib.Comment(), TargetAttrib.Status, strMessage)
        Exit Function
    End If
    
    ' ܂ŗȂ΁ANŃ^O̐؂oɐĂƂB
    ' AJ[݂邩B
    Call SearchAnchor(FilePathList(lngFound).Index, strAnchorName, TargetAttrib)
    
    
    Exit Function
    
ErrorHandler:
    LinkCheckLocal = 1

    TargetAttrib.Status = 99
    Call AddCheckComment(TargetAttrib.Comment(), TargetAttrib.Status, _
                         "m̃G[ɂAŇ؂Ɏs܂B")

End Function


'=====================================================================
' HtmlAttribute \̂󂯎AOɏouÑtpXvԂB
' {I FullPath ô܂ܕԂ̂AValue oƓƂ݂Ȃ
' ꍇ͋󕶎ԂB
' WriteLog() ֐ĂяoAX[u֐B
'---------------------------------------------------------------------
'  : TargetAttrib : ΏۂƂȂ HtmlAttribute \́B
'---------------------------------------------------------------------
' ߂l : OɏouÑtpXv
'---------------------------------------------------------------------
Public Function LogFullPath( _
    TargetAttrib As HtmlAttribute) As String

    On Error GoTo ErrorHandler
    
    Dim boolLocal As Boolean
    Dim strValue As String:  strValue = AoyeHtml.TrimQuote(TargetAttrib.Value)
    Dim lngFound As Long
    
    ' Status  300 ȏ̏ꍇ͈ꗥɋ󕶎ԂďIB
    If TargetAttrib.Status >= 300 Then GoTo ErrorHandler
    
    ' Status  100 Ȃ΁A[J pX̃tO𗧂ĂB
    If TargetAttrib.Status < 100 Then boolLocal = True
    
    ' FullPath o Value o DOS pXƂĂ̔rŊɈقȂĂȂ΁A
    ' FullPath o̒lԂďIB
    If AoyeFileList.StrCompDos(TargetAttrib.FullPath, strValue) <> 0 Then
        LogFullPath = TargetAttrib.FullPath
        
    ' ҂ DOS pXƂēȂ΁A
    Else
        ' AJ[w肳Ă邩B
        lngFound = InStr(1, strValue, "#", 0)
        ' AJ[w肳ĂȂ΁A
        If lngFound > 0 Then
            ' AJ[ȍ~oCirňقȂȂ΁AFullPath oԂB
            If StrComp(Mid$(TargetAttrib.FullPath, lngFound), _
                       Mid$(strValue, lngFound), 0) <> 0 Then
                LogFullPath = TargetAttrib.FullPath
            ' AJ[ȍ~ɈႢȂȂ΁AAJ[ÖႢB
            Else
                ' [JȃpX̏ꍇ
                If boolLocal Then
                    ' DOS pXƂĈႢȂ΁A
                    If AoyeFileList.StrCompDos(Left$(TargetAttrib.FullPath, lngFound), _
                                               Left$(strValue, lngFound)) <> 0 Then
                        LogFullPath = TargetAttrib.FullPath
                    Else
                        LogFullPath = ""
                    End If
                ' [gȃpX̏ꍇ
                Else
                    ' URL ƂĈႢȂ΁A
                    If StrCompUrl(Left$(TargetAttrib.FullPath, lngFound), _
                                  Left$(strValue, lngFound)) <> 0 Then
                        LogFullPath = TargetAttrib.FullPath
                    Else
                        LogFullPath = ""
                    End If
                End If
            
            End If
        
        ' AJ[̎w肪Ȃ΁A
        Else
            ' [JȃpX̏ꍇ
            If boolLocal Then
                ' DOS pXƂĈႢȂ΁A
                If AoyeFileList.StrCompDos(Left$(TargetAttrib.FullPath, lngFound), _
                                           Left$(strValue, lngFound)) <> 0 Then
                    LogFullPath = TargetAttrib.FullPath
                Else
                    LogFullPath = ""
                End If
            ' [gȃpX̏ꍇ
            Else
                ' URL ƂĈႢȂ΁A
                If StrCompUrl(Left$(TargetAttrib.FullPath, lngFound), _
                              Left$(strValue, lngFound)) <> 0 Then
                    LogFullPath = TargetAttrib.FullPath
                Else
                    LogFullPath = ""
                End If
            End If
        
        End If
    
    End If

    Exit Function
    
ErrorHandler:
    LogFullPath = ""

End Function


'=====================================================================
' vOJńAINI t@C̏݁B
'---------------------------------------------------------------------
Public Function ReadIni( _
    ) As Byte

    On Error GoTo ErrorHandler
    
    Dim strLine As String
    Dim strSectionName As String
    Dim strEntryName As String
    Dim strEntryValue As String
    
    Dim strCurrentSection As String
    
    Dim lngCheckSetId As Long:  lngCheckSetId = -1
    
    Dim intFileNo As Integer
    intFileNo = FreeFile

    '-------------------------------------
    ' ftHgl̐ݒB
    
    frmMain.chkLocalCheck = 1
    frmMain.chkRemoteCheck = 0
    strgLogFileDirectory = ""
    bytgLogFileIncrement = 0
    bytgLogType = 0
    bytgAlwaysLogRemoteLink = 0
    bytgTrimLogPath = 1
    bytgUseSlashLogPath = 1
    bytgFileNameCaseSensitive = 1

    '-------------------------------------

    ' INI t@C݂ȂȂ΁A֐𔲂B
    If AoyeFilePath.IsExistAs(strgIniFileName) <> 1 Then Exit Function
    
    ' iVersion 1.*j INI t@C݂ꍇ͂ǂ݁A֐𔲂B
    If ReadIniOld() = 0 Then Exit Function

    Open strgIniFileName For Input As #intFileNo
    
    Do Until EOF(intFileNo)
        Input #intFileNo, strLine
        
        Select Case AoyeApp.ReadIniLine( _
                        strLine, strSectionName, strEntryName, strEntryValue)
            Case 2  ' ZNV̏ꍇ
            
                ' X̃`FbNZbgɊւZNVȂ΁A
                If strSectionName Like "Check Set*" Then
                    lngCheckSetId = lngCheckSetId + 1
                    ' `FbN ZbgzB
                    ReDim Preserve CheckSet(0 To lngCheckSetId)
                    ReDim CheckSet(lngCheckSetId).DefaultDocument(0 To 0)
                    ReDim CheckSet(lngCheckSetId).HtmlFilePattern(0 To 0)
                    ReDim CheckSet(lngCheckSetId).HtmlFilePatternL(0 To 0)
                    ReDim CheckSet(lngCheckSetId).FilePatternX(0 To 0)
                    ReDim CheckSet(lngCheckSetId).DirPatternX(0 To 0)
                    
                    CheckSet(lngCheckSetId).SetName = _
                        LTrim$(Mid$(strSectionName, InStr(1, strSectionName, "-", 0) + 1))
                
                    ' CtH[̃R{{bNXɁAvfǉB
                    frmMain.cmbTargetSet.AddItem CheckSet(lngCheckSetId).SetName
                    frmMain.cmdEditSet.Enabled = True
                    frmMain.cmdDeleteSet.Enabled = True
                End If
                
                strCurrentSection = strSectionName
                
            Case 3  ' Gg̏ꍇ
            
                ' X̃`FbNZbgɊւZNVȂ΁A
                If strCurrentSection Like "Check Set*" Then
                
                    Select Case strEntryName
                        Case "LocalPath"
                            CheckSet(lngCheckSetId).LocalPath = strEntryValue
                        Case "Url"
                            CheckSet(lngCheckSetId).Url = strEntryValue
                        Case "DefaultDocument"
                            Call AoyeFilePath.SplitStringByLetter( _
                                     strEntryValue, ";", _
                                     CheckSet(lngCheckSetId).DefaultDocument())
                        Case "HtmlFilePattern"
                            Call AoyeFilePath.SplitStringByLetter( _
                                     strEntryValue, ";", _
                                     CheckSet(lngCheckSetId).HtmlFilePattern())
                            ' Like Zpp^[̔z쐬B
                            Call HtmlLink.DosWcToLikeWcArray( _
                                     CheckSet(lngCheckSetId).HtmlFilePatternL, _
                                     CheckSet(lngCheckSetId).HtmlFilePattern)
                        Case "AllowBackSlash"
                            CheckSet(lngCheckSetId).AllowBackSlash = CByte(strEntryValue)
                        Case "AllowLocalFullPath"
                            CheckSet(lngCheckSetId).AllowLocalFullPath = _
                                                                     CByte(strEntryValue)
                        Case "CheckMailTo"
                            CheckSet(lngCheckSetId).CheckMailTo = CByte(strEntryValue)
                        Case "CheckBaseDirOver"
                            CheckSet(lngCheckSetId).CheckBaseDirOver = CByte(strEntryValue)
                        Case "AlertDirListing"
                            CheckSet(lngCheckSetId).AlertDirListing = CByte(strEntryValue)
                        Case "StrictAnchorDescription"
                            CheckSet(lngCheckSetId).StrictAnchorDescription = _
                                                                      CByte(strEntryValue)
                        Case "AlertIgnoredFile"
                            CheckSet(lngCheckSetId).AlertIgnoredFile = CByte(strEntryValue)
                        Case "AlertIgnoredNameAnchor"
                            CheckSet(lngCheckSetId).AlertIgnoredNameAnchor = _
                                                                       CByte(strEntryValue)
                        Case "AlertIgnoredIdAnchor"
                            CheckSet(lngCheckSetId).AlertIgnoredIdAnchor = _
                                                                       CByte(strEntryValue)
                        
                        '---------
                        Case "FileAttribute"
                            CheckSet(lngCheckSetId).FileAttribute = CByte(strEntryValue)
                        Case "FilePatternXEnabled"
                            CheckSet(lngCheckSetId).FilePatternXEnabled = _
                                                                    CByte(strEntryValue)
                        Case "FilePatternX"
                           Call AoyeFilePath.SplitStringByLetter( _
                                    strEntryValue, ";", _
                                    CheckSet(lngCheckSetId).FilePatternX())
                        Case "DirAttribute"
                            CheckSet(lngCheckSetId).DirAttribute = CByte(strEntryValue)
                        Case "DirPatternXEnabled"
                            CheckSet(lngCheckSetId).DirPatternXEnabled = _
                                                                   CByte(strEntryValue)
                        Case "DirPatternX"
                           Call AoyeFilePath.SplitStringByLetter( _
                                    strEntryValue, ";", _
                                    CheckSet(lngCheckSetId).DirPatternX())
                        
                    End Select
                
                ' [Settings] ZNVȂ΁A
                ElseIf strCurrentSection = "Settings" Then
                    Select Case strEntryName
                        Case "WindowTop"
                            frmMain.Top = CLng(strEntryValue)
                        Case "WindowLeft"
                            frmMain.Left = CLng(strEntryValue)
                        Case "SetId"
                            lnggSetId = CLng(strEntryValue)
                        Case "LocalCheck"
                            frmMain.chkLocalCheck = CByte(strEntryValue)
                        Case "RemoteCheck"
                            frmMain.chkRemoteCheck = CByte(strEntryValue)
                        Case "LogFileDirectory"
                            strgLogFileDirectory = strEntryValue
                        Case "LogFileIncrement"
                            bytgLogFileIncrement = CByte(strEntryValue)
                        Case "LogType"
                            bytgLogType = CByte(strEntryValue)
                        Case "AlwaysLogRemoteLink"
                            bytgAlwaysLogRemoteLink = CByte(strEntryValue)
                        Case "TrimLogPath"
                            bytgTrimLogPath = CByte(strEntryValue)
                        Case "UseSlashLogPath"
                            bytgUseSlashLogPath = CByte(strEntryValue)
                        Case "FileNameCaseSensitive"
                            bytgFileNameCaseSensitive = CByte(strEntryValue)
                    
                    End Select
                
                End If
                
            
            Case Else  ' ZNVłGgłȂꍇ́AB
        
        End Select
    Loop
    
    Close #intFileNo
    
    ' CtH[̃R{{bNX̑IԂݒB
    If frmMain.cmbTargetSet.ListCount > 0 Then
        If lnggSetId < 0 Then
            lnggSetId = 0
        ' O񃆁[U`FbNZbg̍폜ĂꍇAlnggSetId R{{bNX
        ' ڐwĂ鎖肦B
        ElseIf lnggSetId > frmMain.cmbTargetSet.ListCount - 1 Then
            lnggSetId = frmMain.cmbTargetSet.ListCount - 1
        End If
        frmMain.cmbTargetSet.ListIndex = lnggSetId
    Else
        lnggSetId = 0
    End If
    
    ' Ot@C̏oB
    If strgLogFileDirectory = "" Then
        strgLogFileDirectory = App.Path
    End If
    If Right$(strgLogFileDirectory, 1) <> "\" Then
        strgLogFileDirectory = strgLogFileDirectory & "\"
    End If
    
    Exit Function
    
ErrorHandler:


End Function


'=====================================================================
' INI t@CJAꂪ Version 1.*  INI t@CȂΓe
' ǂ݂݁AO[oϐփZbgB
' Version 2.0 ȍ~ INI t@CȂΉȂB
' INI t@C݂邱Ƃ͊ɊmFς݂ƂOB
'---------------------------------------------------------------------
' ߂l : 0 : Version 1.*  INI t@C݂B
'              eϊœǂݍ񂾁B
'          1 : Version 2.0 ȍ~ INI t@C݂B
'          2 : 炩̃G[NB
'---------------------------------------------------------------------
Public Function ReadIniOld( _
    ) As Byte

    On Error GoTo ErrorHandler
    
    Dim strBuffer As String
    Dim strLine As String
    Dim strSectionName As String
    Dim strEntryName As String
    Dim strEntryValue As String
    Dim intFileNo As Integer:  intFileNo = FreeFile
    
    ' ܂AINI t@CŜǂݍށB
    If AoyeFileIo.ReadTextFile(strgIniFileName, strBuffer, 0) = 0 Then GoTo ErrorHandler

    ' "AlwaysLogRemoteLink", "FileNameCaseSensitive" ƂLqȂ΁A
    ' Version 2.0 ȍ~̃t@CƂ݂ȂA֐𔲂B
    If InStr(1, strBuffer, "AlwaysLogRemoteLink", 0) > 0 And _
       InStr(1, strBuffer, "FileNameCaseSensitive", 0) Then
        ReadIniOld = 1
        Exit Function
    End If

    ' ܂łAVersion 1.*  INI t@CƂ݂ȂB
    
    ' `FbNZbgǉB
    lnggSetId = 0
    CheckSet(lnggSetId).SetName = "`FbN Zbg 1"
    
    ' ftHglKpB
    CheckSet(lnggSetId).FileAttribute = 1
    CheckSet(lnggSetId).FilePatternXEnabled = 1
    CheckSet(lnggSetId).FilePatternX(0) = "*.bak;*.log"
    CheckSet(lnggSetId).DirAttribute = 1
    CheckSet(lnggSetId).DirPatternXEnabled = 0
    CheckSet(lnggSetId).DirPatternX(0) = ""

    CheckSet(lnggSetId).Url = ""
    CheckSet(lnggSetId).HtmlFilePattern(0) = "*.*htm*"
    CheckSet(lnggSetId).HtmlFilePatternL(0) = "*.*[Hh][Tt][Mm]*"

    CheckSet(lnggSetId).AllowBackSlash = 0
    CheckSet(lnggSetId).AllowLocalFullPath = 0
    CheckSet(lnggSetId).CheckMailTo = 1
    CheckSet(lnggSetId).CheckBaseDirOver = 1
    CheckSet(lnggSetId).AlertDirListing = 1
    CheckSet(lnggSetId).StrictAnchorDescription = 0

    CheckSet(lnggSetId).AlertIgnoredFile = 1
    CheckSet(lnggSetId).AlertIgnoredNameAnchor = 0
    CheckSet(lnggSetId).AlertIgnoredIdAnchor = 0
    
    ' CtH[̃R{{bNXɁAvfǉB
    frmMain.cmbTargetSet.AddItem CheckSet(lnggSetId).SetName
    frmMain.cmbTargetSet.ListIndex = lnggSetId
    frmMain.cmdEditSet.Enabled = True
    frmMain.cmdDeleteSet.Enabled = True
    
    ' ۂ INI t@C̓eǂށB
    Open strgIniFileName For Input As #intFileNo
    
    Do Until EOF(intFileNo)
        Input #intFileNo, strLine  ' sǂݍ݁A
        ' Gg̏ꍇ
        If AoyeApp.ReadIniLine( _
               strLine, strSectionName, strEntryName, strEntryValue) = 3 Then
            
            Select Case strEntryName
                Case "WindowLeft":  frmMain.Left = CLng(strEntryValue)
                Case "WindowTop":   frmMain.Top = CLng(strEntryValue)
                
                Case "DefaultPath"
                    CheckSet(lnggSetId).LocalPath = strEntryValue
                Case "DefaultDocument"
                    ReDim CheckSet(lnggSetId).DefaultDocument(0 To 0)
                    CheckSet(lnggSetId).DefaultDocument(0) = strEntryValue
                'Case "CheckSubDirectory"  '  
                'Case "CheckAnchor"  '  
                'Case "CheckLink"  '  
                'Case "CheckFile"  '  
                Case "LogAppearence"
                    If CByte(strEntryValue) = 1 Then  ' tpX`
                        bytgTrimLogPath = 0
                        bytgUseSlashLogPath = 0
                    Else  ' URL `
                        bytgTrimLogPath = 1
                        bytgUseSlashLogPath = 1
                    End If
                Case "CeseSensitive"
                    bytgFileNameCaseSensitive = 1 - CByte(strEntryValue)
                'Case "IsolatedFile"  '  
                                
            End Select

        End If
    Loop

    Close #intFileNo

    ReadIniOld = 0

    Exit Function
    
ErrorHandler:
    ReadIniOld = 2

End Function


'=====================================================================
' String ^̓Iz󂯎A
' (1) evfɂāA[̃Xy[XENH[gg~OB
' (2) DOS t@CƂĂ̏dvf폜B
' (3) 󕶎vf폜B
' z̏Ԃ͕ێB
'---------------------------------------------------------------------
'  : strTarget() : ΏۂƂȂADOS t@C̔zB
'---------------------------------------------------------------------
' ߂l : 0 ȏ : IȗvfB
'         -1 : G[IB
'---------------------------------------------------------------------
Public Function ReduceStringArray(strTarget() As String)

    On Error GoTo ErrorHandler
    
    Dim lngI As Long
    Dim lngJ As Long
    Dim boolEmptyFlag As Boolean
    
    ' g~OB
    For lngI = LBound(strTarget) To UBound(strTarget)
        strTarget(lngI) = AoyeFilePath.TrimPathString(strTarget(lngI))
    Next lngI
    
    ' ŁAdvfȂ`FbNB
    For lngI = LBound(strTarget) To UBound(strTarget) - 1
        If strTarget(lngI) <> "" Then
            For lngJ = lngI + 1 To UBound(strTarget)
                ' dĂÂق̗vf󕶎ɂB
                If AoyeFileList.StrCompDos(strTarget(lngI), strTarget(lngJ)) = 0 Then
                    strTarget(lngJ) = ""
                End If
            Next lngJ
        End If
    Next lngI
    
    ' 󕶎vf𖳂悤ɁAvfO֋l߂B
    For lngI = LBound(strTarget) To UBound(strTarget) - 1
        Do While strTarget(lngI) = ""
            boolEmptyFlag = True
            For lngJ = lngI + 1 To UBound(strTarget)
                If strTarget(lngJ) <> "" Then boolEmptyFlag = False
                strTarget(lngJ - 1) = strTarget(lngJ)
            Next lngJ
            strTarget(UBound(strTarget)) = ""
            
            If boolEmptyFlag Then Exit Do
        Loop
    Next lngI
    
    ' ɏW܂󕶎vfA폜B
    For lngI = LBound(strTarget) + 1 To UBound(strTarget)
        If strTarget(lngI) = "" Then
            ReDim Preserve strTarget(LBound(strTarget) To lngI - 1)
        End If
    Next lngI
    
    ReduceStringArray = UBound(strTarget) - LBound(strTarget) + 1
    If strTarget(LBound(strTarget)) = "" Then ReduceStringArray = 0
    
    Exit Function
    
ErrorHandler:
    ReduceStringArray = -1

End Function


'=====================================================================
' HtmlFile() z index ԍ󂯎Ãt@C
' ̃AJ[Lq܂܂Ă邩ǂ؂B
'---------------------------------------------------------------------
'  : lngF         : HtmlFile() zɂ index ԍB
'                       ̃t@CؑΏۂƂȂB
'        strAnchor    : TAJ[LqB
'        TargetAttrib : strAnchor ̊܂܂ HtmlAttribute \́B
'                       AJ[Lq̑ۂɉăbZ[WǉB
'---------------------------------------------------------------------
' ߂l : 0 : I
'          1 : ُI
'---------------------------------------------------------------------
Public Function SearchAnchor( _
    lngF As Long, strAnchor As String, TargetAttrib As HtmlAttribute) As Byte

    On Error GoTo ErrorHandler
    
    Dim lngH As Long  ' Anchor() z index
    Dim lngT As Long  ' Tag() z index
    Dim lngA As Long  ' Attrib() z index
    
    Dim lngStatus As Long
    Dim strMessage As String
    
    Dim lngFound As Long
    
    ' y[WAJ[ (ex. "#AnchorName") ł邩ǂ̃tOB
    Dim boolWithinPage As Boolean
    If Left$(AoyeHtml.TrimQuote(TargetAttrib.Value), 1) = "#" Then boolWithinPage = True
    
    ' t@CɋLqĂeAJ[LqɂāA
    For lngH = LBound(HtmlFile(lngF).Anchor) To UBound(HtmlFile(lngF).Anchor)
        
        lngT = HtmlFile(lngF).Anchor(lngH).TagId
        lngA = HtmlFile(lngF).Anchor(lngH).AttribId
        
        If lngT < 0 Then  ' XgȂ΁A[v𔲂B
            lngH = UBound(HtmlFile(lngF).Anchor) + 1
            Exit For
        End If
        
        ' Ƃė^ꂽAJ[LqAlngH Ń|CgĂ鑮l̂
        ' oCiňvȂ΁A
        If StrComp(strAnchor, _
                   AoyeHtml.TrimQuote(HtmlFile(lngF).Tag(lngT).Attrib(lngA).Value), 0) _
            = 0 Then
        
            lngFound = lngFound + 1
            ' 탊N񐔂CNg
            HtmlFile(lngF).Anchor(lngH).Linked = HtmlFile(lngF).Anchor(lngH).Linked + 1
            HtmlFile(lngF).Linked = HtmlFile(lngF).Linked + 1
        
            ' AJ[`́ioCił́jdNĂȂȂ΁A
            ' ̎_Ń[v𔲂Ă悢B
            If HtmlFile(lngF).Anchor(lngH).Doubled < 2 Then
                lngStatus = 90
                strMessage = ""
                Exit For
            ' AJ[`̏dNĂA̍ŏ̏ołȂ΁A
            ElseIf lngFound = 1 Then
                lngStatus = 19  ' bZ[WǉB
                strMessage = "̃AJ[́A"
                If boolWithinPage Then
                    strMessage = strMessage & "̃y[W"
                Else
                    strMessage = strMessage & "Nt@C"
                End If
                strMessage = strMessage & "d`Ă܂B"
            End If

        End If
        
    Next lngH

    ' strAnchor ΏۂƂȂt@CŌȂȂ΁A
    If lngFound = 0 Then
        lngStatus = 18
        strMessage = "w肳ꂽAJ[܂B"
        ' y[WAJ[ (ex. "#AnchorName") łȂȂ΁A
        ' t@Ĉւ̃N͂łĂ邱ƂB
        If Not boolWithinPage Then
            strMessage = strMessage & "it@C݂͑܂Bj"
        End If
    End If
    
    ' Status lȂǂǉB
    TargetAttrib.Status = lngStatus
    If strMessage <> "" Then
        Call AddCheckComment(TargetAttrib.Comment(), lngStatus, strMessage)
    End If

    SearchAnchor = 0

    Exit Function
    
ErrorHandler:
    SearchAnchor = 1

End Function


'=====================================================================
' URL Lq󂯎AvgRƃT[o𔲂oB
'  : "http://www.yahoo.com/home/index.htm"  "http://www.yahoo.com"
' ۂ AoyeFilePath.SplitPathExpression ́A؂蕪ʂ̑vf
' PɕԂłB
'---------------------------------------------------------------------
'  : strTarget : Ώۂ URL LqB
'---------------------------------------------------------------------
' ߂l : strTarget ̃T[o܂ł𔲂óB "/" ͂ȂB
'---------------------------------------------------------------------
Public Function ServerPath( _
    strTarget As String) As String

    On Error GoTo ErrorHandler
    
    Dim strDrive As String
    Dim strParentDirectory As String
    Dim strFile As String
    
    If strTarget = "" Then
        ServerPath = ""
    Else
        Call SplitPathExpression(strTarget, "", strDrive, strParentDirectory, strFile)
        ServerPath = strDrive
    End If

    Exit Function
    
ErrorHandler:
    ServerPath = ""

End Function


'=====================================================================
'  URL 󂯎A҂B
' URL ́AvgRƃT[oɊւĂ͑啶EʂA
' fBNgƃt@CɂĂ͑啶E̋ʂB
' ̓_lrsȂB
'---------------------------------------------------------------------
'  : strTargetA : rΏۂƂȂ镶 1
'        strTargetB : rΏۂƂȂ镶 2
'---------------------------------------------------------------------
' ߂l : -1 : A  B ɗB
'           0 : A  B ͓B
'           1 : B  A ɗB
'          G[Nꍇ 0 ԂB
'---------------------------------------------------------------------
Public Function StrCompUrl( _
    ByVal strTargetA As String, ByVal strTargetB As String) As Integer

    On Error GoTo ErrorHandler

    Dim strServerA As String:  Dim strDirectoryA As String:  Dim strFileA As String
    Dim strServerB As String:  Dim strDirectoryB As String:  Dim strFileB As String
    
    ' ҂oCirňvȂ΁A 0 ԂĂ悢B
    If StrComp(strTargetA, strTargetB, 0) = 0 Then
        StrCompUrl = 0
        Exit Function
    End If
    
    ' ^ꂽ҂ɂāAvgRET[oAfBNgAt@CɕB
    Call AoyeFilePath.SplitPathExpression( _
             strTargetA, "", strServerA, strDirectoryA, strFileA)
    Call AoyeFilePath.SplitPathExpression( _
             strTargetB, "", strServerB, strDirectoryB, strFileB)
    
    ' vgRET[óAignore case ŔrB
    StrCompUrl = AoyeHtml.StrCompIc(strServerA, strServerB)
    
    ' ̎_ňႢoA֐𔲂Bi߂l͊ɓĂBj
    If StrCompUrl <> 0 Then Exit Function
    
    ' ႢoȂȂ΁AfBNgƃt@CAăoCirB
    StrCompUrl = StrComp(strDirectoryA & strFileA, strDirectoryB & strFileB, 0)
    
    Exit Function
    
ErrorHandler:
    StrCompUrl = 0

End Function


'=====================================================================
' t@C̃tpX󂯎Ãt@CAw肳ꂽt@Cp^[
' v邩ǂ؂B
'---------------------------------------------------------------------
'  : strFileName : ؂t@C̃tpXLqB
'                      Ȃ炸t@C܂܂i"\"  "/" ŏIĂȂjƂ
'                      OƂB
'        strHtmlFilePatternL() : t@Cp^[̔zB̗vfA
'                                Like Zp̃p^[ɂȂĂ邱ƁB
'                                iDOS pp^[ł͕sBj
'---------------------------------------------------------------------
' ߂l : True  : ^ꂽp^[̂ǂꂩȏɍvB
'          False : ǂ̃p^[ɂvȂB
'---------------------------------------------------------------------
Private Function ValidFileNamePattern( _
    ByVal strFileName As String, strHtmlFilePatternL() As String) As Boolean

    On Error GoTo ErrorHandler
    
    Dim lngI As Long
    
    ' strFileName ̖A"\"  "/" oʒuTB
    ' A̒ȍ~t@CƂĎ擾B
    For lngI = Len(strFileName) To 1 Step -1
        If Mid$(strFileName, lngI, 1) Like "[\/]" Then
            strFileName = Mid$(strFileName, lngI + 1)
            Exit For
        End If
    Next lngI

    ' 擾ꂽt@CAꂼ̃p^[ɓ˂킹B
    For lngI = LBound(strHtmlFilePatternL) To UBound(strHtmlFilePatternL)
        If strFileName Like strHtmlFilePatternL(lngI) Then
            ValidFileNamePattern = True  ' p^[ɍvATrue ԂďIB
            Exit Function
        End If
    Next lngI
    
'  For [v𔲂Ă܂Â܂ ErrorHandler ʂ点B
ErrorHandler:
    ValidFileNamePattern = False

End Function


'=====================================================================
' HtmlFileStructure \̂󂯎At@CŒ`ĂAJ[
' dsȋLq؂B
'---------------------------------------------------------------------
'  : TargetFile : Ώۂ HtmlFile \́B
'---------------------------------------------------------------------
' ߂l : 0 : I
'          1 : G[I
'---------------------------------------------------------------------
' Note : AJ[`̗Bꐫ Case Ignore łB
'        ܂A"apple", "APPLE" 𓯈y[Wɒ`邱Ƃ͂łȂB
'        AAJ[ւ̃NLq Case Sensitive łB
'        ܂A"#APPLE" ƂNLq "apple" փWv邱Ƃ͂łȂB
'        ȏ𓥂܂ŁAd`̗ƂĈȉ 3 lB
'
'        (a) "apple", "APPLE", "banana"
'        (b) "apple", "APPLE", "APPLE"
'        (c) "APPLE", "APPLE", "banana"
'
'        "#APPLE" ƂNLqłꂼփNꍇA
'        (a) = "APPLE" ̈ʒuӂɌ܂B
'        (b), (c) = "APPLE" ̈ʒuӂɌ܂ȂB
'
'        āA3 Ƃ Case Igonore ŏdNĂ邪A
'        (b), (c) ł͂ Case Sensitive ł̏dNĂƂ_ŁA
'        ɕʃO[vɕׂłB
'        ̓Iɂ́A(a)  "#APPLE" ŃNꍇ͓ɌxoKv͖A
'        (b), (c) ̏ꍇ́uN悪ӂɌ܂܂vƂxoׂłB
'---------------------------------------------------------------------
Public Function VerifyAnchorArray( _
    TargetFile As HtmlFileStructure) As Byte

    On Error GoTo ErrorHandler
    
    Dim lngI As Long
    Dim lngJ As Long
    Dim lngStatus As Long
    Dim strMessage As String
    
    Dim lngT As Long
    Dim lngA As Long
    Dim boolCheckFlag As Boolean
    
    Dim strAnchor() As String
    ReDim strAnchor(LBound(TargetFile.Anchor) To UBound(TargetFile.Anchor))
    
    ' AJ[Lq̔zipɁj쐬B
    For lngI = LBound(TargetFile.Anchor) To UBound(TargetFile.Anchor)
        If TargetFile.Anchor(lngI).TagId < 0 Then Exit For
        strAnchor(lngI) = AoyeHtml.TrimQuote( _
                              TargetFile.Tag(TargetFile.Anchor(lngI).TagId). _
                                         Attrib(TargetFile.Anchor(lngI).AttribId).Value)
    Next lngI
    
    ' ꂼ̃AJ[LqɂāA
    For lngI = LBound(TargetFile.Anchor) To UBound(TargetFile.Anchor)
        ' Xg̖܂ŗĂȂ΁A[vIB
        If TargetFile.Anchor(lngI).TagId < 0 Then Exit For
        
        lngT = TargetFile.Anchor(lngI).TagId
        lngA = TargetFile.Anchor(lngI).AttribId
        
        ' AJ[Lq󕶎̏ꍇB
        If strAnchor(lngI) = "" Then
            TargetFile.Tag(lngT).Attrib(lngA).Status = 520
            ' bZ[WǉāA
            Call HtmlLink.AddCheckComment(TargetFile.Tag(lngT).Attrib(lngA).Comment, _
                                          TargetFile.Tag(lngT).Attrib(lngA).Status, _
                                          "AJ[łB")
            GoTo LoopI_End  ' continue B
        End If
        
        ' ȑO Case Sensitive ł̏d`FbNɈĂȂȂ΁A
        If TargetFile.Anchor(lngI).Doubled < 2 Then
        
            ' ȍ~ŏdNĂȂ؂
            For lngJ = lngI + 1 To UBound(TargetFile.Anchor)
                strMessage = ""
            
                ' pAt@xbgɌ Case Ignore ňvȂ΁A
                If AoyeFileList.StrCompDos(strAnchor(lngI), strAnchor(lngJ)) = 0 Then
                    ' lngJ ̑܂d`FbNɈĂȂꍇA
                    If TargetFile.Anchor(lngJ).Doubled = 0 Then
                        ' bZ[WǉB
                        strMessage = "̃AJ[͊ " & _
                                     TargetFile.Tag(lngT).Attrib(lngA).RealLine & _
                                     " sڂŒ`Ă܂B"
                    End If
                    
                    ' Case Sensitive ł̈v̏ꍇB
                    If StrComp(strAnchor(lngI), strAnchor(lngJ), 0) = 0 Then
                        TargetFile.Anchor(lngI).Doubled = 2
                        TargetFile.Anchor(lngJ).Doubled = 2
                    ' Case Ignore ł̈v̏ꍇB
                    Else
                        If TargetFile.Anchor(lngI).Doubled = 0 Then
                            TargetFile.Anchor(lngI).Doubled = 1
                        End If
                        If TargetFile.Anchor(lngJ).Doubled = 0 Then
                            TargetFile.Anchor(lngJ).Doubled = 1
                        End If
                    End If
                    
                    If strMessage <> "" Then
                        Call HtmlLink.AddCheckComment( _
                            TargetFile.Tag(TargetFile.Anchor(lngJ).TagId). _
                                       Attrib(TargetFile.Anchor(lngJ).AttribId).Comment, _
                            500 + TargetFile.Anchor(lngJ).Doubled, strMessage)
                    End If
                End If
            Next lngJ
            
        End If
        
        lngStatus = TargetFile.Anchor(lngI).Doubled
        
        ' iKvȂ΁jsȕgĂȂ؂B
        If CheckSet(lnggSetId).StrictAnchorDescription > 0 Then
            boolCheckFlag = False
            ' ꕶڂ̓At@xbgłȂ΂ȂB
            If strAnchor(lngI) Like "[A-Za-z]*" Then
                ' 񕶎ڈȍ~A̕܂܂ĂĂ͂ȂB
                If strAnchor(lngI) Like "*[!-.0-9;A-Z_a-z]*" Then
                    boolCheckFlag = True
                Else
                    boolCheckFlag = False
                End If
            Else
                boolCheckFlag = True
            End If
            ' sȕ܂܂ĂȂ΁A
            If boolCheckFlag Then
                lngStatus = lngStatus + 10
                Call HtmlLink.AddCheckComment(TargetFile.Tag(lngT).Attrib(lngA).Comment, _
                                              510, _
                                              "AJ[ɕsȕ܂܂Ă܂B")
            End If
        End If
        
        TargetFile.Tag(lngT).Attrib(lngA).Status = _
        TargetFile.Tag(lngT).Attrib(lngA).Status + lngStatus
LoopI_End:
    Next lngI
    
    VerifyAnchorArray = 0
    
    Exit Function
    
ErrorHandler:
    VerifyAnchorArray = 1

End Function


'=====================================================================
' HtmlTag \̂󂯎Ȃɏd邩A邢͕K{ĂȂA
' `FbNsȂB`FbNɈȂ΁A
' Status l Comment() vfǉB
'---------------------------------------------------------------------
'  : TargetTag : ΏۂƂȂ HtmlTag \́B
'---------------------------------------------------------------------
' ߂l : 0 : I
'          1 : G[I
'---------------------------------------------------------------------
Private Function VerifyAttributeArray( _
    TargetTag As HtmlTag) As Byte

    On Error GoTo ErrorHandler
    
    Dim lngI As Long
    Dim lngJ As Long
    Dim strTargetAttr() As String
    ReDim strTargetAttr(LBound(TargetTag.Attrib) To UBound(TargetTag.Attrib))
    
    Dim strLostAttrib As String
    Dim strDoubledAttrib As String
    Dim boolDoubledFlag As Boolean
    
    ' ^ꂽ^Ȏ̔zATargetTag ̗vfRs[č쐬
    For lngI = LBound(TargetTag.Attrib) To UBound(TargetTag.Attrib)
        strTargetAttr(lngI) = TargetTag.Attrib(lngI).Name
    Next lngI
    
    '-----------------------------------------------------------
    '  ܂AK{̑ĂȂ`FbNB
    
    ' <a> ^ȌꍇA"href" A"name" A"id" ̂ǂȂꍇ
    ' ߂ČxΏۂƂȂ
    If TargetTag.Name Like "[Aa]" Then
        ' ^ꂽeꂼɂāA
        For lngI = LBound(strTargetAttr) To UBound(strTargetAttr)
            ' "href" 邢 "name"  邢 "id" ǂ炩ɊYȂ`FbNB
            If strTargetAttr(lngI) Like "[Hh][Rr][Ee][Ff]" Or _
               strTargetAttr(lngI) Like "[Nn][Aa][Mm][Ee]" Or _
               strTargetAttr(lngI) Like "[Ii][Dd]" Then
                Exit For
            End If
        Next lngI
        '  For [v肫Ă܂AǂSȂƂB
        If lngI > UBound(strTargetAttr) Then
            Call AddCheckComment(TargetTag.Comment(), 2, _
                     "href Aname Aid ̂ݒ肳Ă܂B")
            TargetTag.Status = TargetTag.Status + 2  ' RgǉAXe[^Xl +2
        End If
    ' <link> ^ȌꍇB
    ElseIf TargetTag.Name Like "[Ll][Ii][Nn][Kk]" Then
        For lngI = LBound(strTargetAttr) To UBound(strTargetAttr)
            If strTargetAttr(lngI) Like "[Hh][Rr][Ee][Ff]" Or _
               strTargetAttr(lngI) Like "[Ss][Rr][Cc]" Then
                Exit For
            End If
        Next lngI
        If lngI > UBound(strTargetAttr) Then
            Call AddCheckComment(TargetTag.Comment(), 2, _
                     "href Asrc ̂ݒ肳Ă܂B")
            TargetTag.Status = TargetTag.Status + 2
        End If
    ' <a> ^OA<link> ^OȊȌꍇB
    ' K{̗L`FbŃALinkTag ɓo^Ă^OɌčsȂ΂悢B
    ElseIf TargetTag.Id >= 0 Then
        ' Y LinkTag vf̊eɂāA
        For lngI = LBound(LinkTag(TargetTag.Id).Attrib) To _
                   UBound(LinkTag(TargetTag.Id).Attrib)
            If LinkTag(TargetTag.Id).Attrib(lngI).Required Then  ' ̑K{ȂA
                ' ^ꂽ^O̊êǂꂩɊYȂ`FbNB
                For lngJ = LBound(strTargetAttr) To UBound(strTargetAttr)
                    If StrCompIc(LinkTag(TargetTag.Id).Attrib(lngI).Name, _
                                 strTargetAttr(lngI)) = 0 Then
                        Exit For
                    End If
                Next lngJ
                '  For [v肫Ă܂A̕K{ƂB
                If lngJ > UBound(strTargetAttr) Then
                    ' ȂƂċLB
                    strLostAttrib = strLostAttrib & _
                                    ", " & LinkTag(TargetTag.Id).Attrib(lngI).Name
                End If
            End If
        Next lngI
        ' Ȃȏ゠Ȃ΁A
        If Len(strLostAttrib) > 0 Then
            strLostAttrib = Mid$(strLostAttrib, 3)  ' ` ", " 폜A
            Call AddCheckComment(TargetTag.Comment(), 2, _
                                 strLostAttrib & " ݒ肳Ă܂B")
            TargetTag.Status = TargetTag.Status + 2  ' RgǉAXe[^Xl +2
        End If
    End If
    
    '-----------------------------------------------------------
    '  ɁȀd`sȂĂȂ`FbNB
    
    For lngI = LBound(strTargetAttr) To UBound(strTargetAttr) - 1
        boolDoubledFlag = False
        If Len(strTargetAttr(lngI)) > 0 Then
            For lngJ = lngI + 1 To UBound(strTargetAttr)
                If StrCompIc(strTargetAttr(lngI), strTargetAttr(lngJ)) = 0 Then
                    strTargetAttr(lngJ) = ""
                    If boolDoubledFlag = False Then
                        boolDoubledFlag = True
                        strDoubledAttrib = strDoubledAttrib & ", " & strTargetAttr(lngI)
                    End If
                End If
            Next lngJ
        End If
    Next lngI
    
    ' dȂ΁A
    If Len(strDoubledAttrib) > 0 Then
        strDoubledAttrib = Mid$(strDoubledAttrib, 3)  ' ` ", " 폜A
        Call AddCheckComment(TargetTag.Comment(), 1, _
                             strDoubledAttrib & " d`Ă܂B")
        TargetTag.Status = TargetTag.Status + 1  ' RgǉAXe[^Xl +1
    End If
    
    '-----------------------------------------------------------
    '  <link> ^OȂ΁Arev="made" `FbNB
    
    If TargetTag.Name Like "[Ll][Ii][Nn][Kk]" Then
        For lngI = LBound(TargetTag.Attrib) To UBound(TargetTag.Attrib)
            ' rev="made" Ƃw肪Ȃ΁A
            If TargetTag.Attrib(lngI).Name Like "[Rr][Ee][Vv]" Then
                If AoyeHtml.TrimQuote(TargetTag.Attrib(lngI).Value) _
                       Like "[Mm][Aa][Dd][Ee]" Then
                    ' tO𗧂ĂB
                    TargetTag.RevMade = True
                    'lngMatched = lngMatched + 1
                    ' ȍ~̗vfO֋l߂B
                    For lngJ = lngI + 1 To UBound(TargetTag.Attrib)
                        TargetTag.Attrib(lngJ - 1) = TargetTag.Attrib(lngJ)
                    Next lngJ
                    ' Ō̗vf폜Azvf炷B
                    ' (rev ̗vf͍폜邱ƂƂȂB)
                    ReDim Preserve TargetTag.Attrib(LBound(TargetTag.Attrib) To _
                                                    UBound(TargetTag.Attrib) - 1)
                    ' [vpJE^߂B
                    lngI = lngI - 1
                End If
            End If
            If lngI >= UBound(TargetTag.Attrib) Then Exit For
        Next lngI
    End If
    
    '-----------------------------------------------------------
    VerifyAttributeArray = 0

    Exit Function
    
ErrorHandler:
    VerifyAttributeArray = 1

End Function


'=====================================================================
' HtmlTag \̂ƁA Attrib() o index ԍiǂ̑l邩j󂯎A
' ꂪpXƂėp\Ȃ̂肵AStatus oɒlZbgB
' ̓Iɂ́A<base> ^O href lA<applet> ^O basecode lȂǁA
' ̃^ÕN摮l̊pXƂčp鑮l̏ɎgB
' p\Ȃ̂ł΁AFullPath oɁAK؂Ȍ`ŃpXZbgB
'---------------------------------------------------------------------
'  : TargetTag : HtmlTag \
'        lngIndex : TargetTag.Attrib() ɂ index ԍBiΏۂ̑Bj
'---------------------------------------------------------------------
' ߂l : TargetTag.Attrib(lngIndex).Status ̒lB
'---------------------------------------------------------------------
Private Function VerifyBasePath( _
    TargetTag As HtmlTag, lngIndex As Long) As Long

    On Error GoTo ErrorHandler
    
    Dim lngStatus As Long
    Dim strFullPath As String
    Dim strMessage As String
    
    Dim strTarget As String  ' ΏۂƂȂ鑮li<base> ^O href lj
    Dim bytPathType As Byte
    Dim lngPointer As Long
    
    strTarget = AoyeHtml.TrimQuote(TargetTag.Attrib(lngIndex).Value)
    bytPathType = DetectPathType(strTarget)
    
    Select Case bytPathType
        Case 1, 2
            ' [JȐ΃pXLqĂȂꍇ
            If CheckSet(lnggSetId).AllowLocalFullPath = 0 Then
                lngStatus = 301
                strMessage = "[JȃtpXw͎g܂B"
            Else
                lngStatus = 300
            End If
            ' Status 301 ɂȂĂApXƂĂ͍̗pB
            strFullPath = strTarget
        
        Case 3  ' "//" vgRLq̏ꍇA
            ' T[ôƂ "/"  "\" ĂȂꍇAG[ƂB
            lngPointer = InStr(1, strTarget, "//", 0)
            If Not Mid$(strTarget, lngPointer + 2) Like "*[\/]*" Then
                lngStatus = 305
                strMessage = "T[o"
                If CheckSet(lnggSetId).AllowLocalFullPath = 1 Then
                    strMessage = strMessage & "i邢̓hCuj"
                End If
                strMessage = strMessage & "̌ ""/"""
                If CheckSet(lnggSetId).AllowBackSlash = 1 Then
                    strMessage = strMessage & "  ""\"""
                End If
                strMessage = strMessage & " KvłB"
            Else
                strFullPath = strTarget
                lngStatus = 300
            End If
        
        Case 4  ' vgRȂ̐΃pXLq̓G[B
            lngStatus = 306
            strMessage = "΃pX̐擪ɃvgRƃT[o"
            If CheckSet(lnggSetId).AllowLocalFullPath = 1 Then
                strMessage = strMessage & "i邢̓hCuj"
            End If
            strMessage = strMessage & "KvłB"
            
        Case 5  ' pXLq΃pXLqB
            ' "." ł͂܂ꍇ́AhCƂ݂͂ȂȂ̂ŁAG[B
            If Left$(strTarget, 1) = "." Then
                lngStatus = 304
                strMessage = "ő΃pX͎g܂B"
            ' "/"  "\" ܂܂Ȃꍇ́AHTTP T[oƂ݂ȂB
            ElseIf InStr(1, strTarget, "/", 0) = 0 And InStr(1, strTarget, "\", 0) = 0 Then
                strFullPath = "http://" & strTarget & "/"
                lngStatus = 300
            Else  ' LȊȌꍇ́AP "http://" 𓪂ɂB
                strFullPath = "http://" & strTarget
                lngStatus = 300
            End If
            
        Case 6  ' pXLq "//" Ȃ̃vgRLqB : "javascript:print..."
            lngStatus = 307
            strMessage = "vgRsłB"
        
        Case 7  ' pXLqij󕶎B
            lngStatus = 308
            strMessage = "lłB"
            ' <base href=""> ƂLqꍇAIE2 ł͎gpXƂ
            ' 삷邪ANN2 ł "DNS Ȃ" ƂG[ƂȂB
            ' Ƃ肠Ȃlw肳ꂽꍇ́AxΏۂƂB
        
        Case Else  ' DetectPathType() ֐ŉ炩̃G[B
            lngStatus = 399
            strMessage = "l̉߂Ɏs܂B"
    
    End Select

    ' ̎_ŃG[bZ[WĂȂ΁A\̂֊i[B
    If Len(strMessage) > 0 Then
        Call AddCheckComment(TargetTag.Attrib(lngIndex).Comment(), lngStatus, strMessage)
    End If

    ' strFullPath  "\" gĂȂ΁Agpɖ肪`FbNB
    If InStr(1, strFullPath, "\", 0) Then
        strMessage = ""
        Select Case CheckSlash(strFullPath)
            Case 1  ' "\" ֎~ɂ炸 "\" gĂꍇ
                lngStatus = 302
                strMessage = "fBNg̋؂L ""\"" ͎g܂B"
            Case 2  ' "\"  "/" ݂̍NĂꍇ
                lngStatus = 303
                strMessage = "fBNg̋؂L ""\""  ""/"" ݂Ă܂B"
        End Select
        ' G[bZ[WĂȂ΁A\̂֊i[B
        If Len(strMessage) > 0 Then
            Call AddCheckComment(TargetTag.Attrib(lngIndex).Comment(), _
                                 lngStatus, strMessage)
        End If
    End If
    ' "http://..." ƂLq̏ꍇɂ̃ubNʂ_ɒӁB

    ' [JȃpX́ADOS iDir$ ֐ɓ`j֕ϊB
    If bytPathType = 1 Or bytPathType = 2 Then
        strFullPath = AoyeHtml.FormatAsDosPath(strFullPath)
    End If
    
    ' ۂɍ\̂֊i[B
    TargetTag.Attrib(lngIndex).Status = lngStatus
    TargetTag.Attrib(lngIndex).FullPath = strFullPath

    VerifyBasePath = TargetTag.Attrib(lngIndex).Status

    Exit Function
    
ErrorHandler:
    TargetTag.Attrib(lngIndex).Status = 399  ' m̃G[
    Call AddCheckComment( _
             TargetTag.Attrib(lngIndex).Comment(), _
             TargetTag.Attrib(lngIndex).Status, "l̉߂Ɏs܂")
    
    VerifyBasePath = TargetTag.Attrib(lngIndex).Status

End Function


'=====================================================================
' HtmlFileStructure ɂ Tag, Attrib ꂼ index ԍƂB
' Ă̑lpXƂ킹Đ΃pXɕϊAFullPath oɊi[B
'---------------------------------------------------------------------
'  : TargetFile : ΏۂƂȂt@CB
'        lngT   : TargetFile.Tag o index ԍ
'        lngA    : TargetFile.Tag(lngT).Attrib o index ԍ
'        bytBasePathStatus : 0 : i΃N̋N_ƂȂjpX͖ȃpXB
'                            1 : pX̓[JȃpXB
'                            2 : pX̓[gȃpXB
'        strBasePathServer : <base> ^OA̓`FbNZbg URL ̃T[oB
'                            T[oȂ̐΃pXLqi: "/apple/banana.htm"j
'                            ߂ɕKvB
'                            ServerPath() ֐̖߂lgB
'                            : "http://www.yahoo.com"
'                            L <base> ^OLqA`FbNZbg URL ̂ǂ
'                            Ȃ΁A󕶎񂪓B
'        strBasePathParent : pX̐efBNg̃pXB
'                            "./" Ŏn܂鑊΃NA邢̓TufBNg
'                            t@CŎn܂鑊΃N̉߂ŎgB
'                            pXi= <base> ^ŐLqsjłꍇ
'                            󕶎񂪓B
'        strRelativeBaseServer : ւǂ鑊΃pX̉߂ŎgpX̃T[oB
'        strRelativeBaseDir()  : ւǂ鑊΃pX̉߂ŎgpX
'                                fBNgB
'                                 2 ͂ AoyeFilePath.SplitPathExpression() 
'                                ؂蕪ʂgBL "Note" ZNVQƂ̂ƁB
'        boolRelativeBaseStatus : True  : strRelativeBase* ϐ́A{[JȃpX
'                                         pXA`FbNZbg URL g
'                                         [g URL ɏ̂łB
'                                 False : strRelativeBase* ϐ́A`FbNZbg URL 
'                                         gpĂȂ
'---------------------------------------------------------------------
' ߂l : TargetFile.Tag(lngT).Attrib(lngA).Status ̒lB
'           TargetFile.Tag(lngT).Attrib() z񂪎J̏ꍇAʂ -1 ԂB
'---------------------------------------------------------------------
' Note : y strRelativeBase* ϐɂ z
'        ΃ŃAʂɃt@Cg̃pXA邢 <base> ^OŒ`ꂽpX
'        pXƂApXǂBւǂ鑊΃N ("../apple/") 
'        ꍇA[gz悤ƂĂȂ̃`FbNKvB
'        `FbNZbgŃ[g URL w肳ĂȂ΁A
'        ́g[g URL Łh[gz悤ƂĂȂ肷ׂłB
'        ]āAւǂ鑊΃N`FbNۂ̊pXƂẮA
'        (1) <base> ^O`ĂȂ΁ÃpXgB
'        (2) <base> ^OȂȂ΁At@Cg̃pXgƂӖB
'            `FbNZbg URL w肳ĂȂ΁A[g URL gB
'        (3) t@Cg̃[JȃpXgB
'        ƂD揇ʂŃpX̗pB
'        ܂A(2) Ń[g URL gƂ̂́A܂ŁgpX߁hƂĂ
'        ꎞIȕ֖@Ȃ̂ŁA[gz`FbNς񂾂Ǎ`i[JȃpXj
'        ߂ȂĂ͂ȂȂB
'        ȏA
'        Ⴆ strBasePathParent ̃pX[JŁAstrRelativeBase* ϐ̃pX
'        [gƂƂ͂肤BbytBasePathStatus ̒l (1 or 2) ́A
'        O҂ɊւlwBstrRelativeBase* ϐ́A܂
'        [gz`FbN̂߂ɓꂽ̂łB
'---------------------------------------------------------------------
Private Function VerifyLinkAttribute( _
    TargetFile As HtmlFileStructure, lngT As Long, lngA As Long, _
    bytBasePathStatus As Byte, strBasePathServer As String, _
    strBasePathParent As String, _
    strRelativeBaseServer As String, strRelativeBaseDir() As String, _
    boolRelativeBaseStatus As Boolean) As Long
    
    On Error GoTo ErrorHandler
    
    Dim lngStatus As Long
    Dim strFullPath As String
    Dim strMessage As String
    
    Dim strTarget As String  ' ΏۂƂȂ鑮l
    Dim bytPathType As Byte
    Dim lngPointer As Long
    
    ' ̂̏ꍇ́AɊ֐𔲂B
    ' TargetTag.Attrib() z񂪎J̏ꍇAɊYB
    If TargetFile.Tag(lngT).Attrib(lngA).Name = "" Then
        TargetFile.Tag(lngT).Attrib(lngA).Status = -1
        VerifyLinkAttribute = TargetFile.Tag(lngT).Attrib(lngA).Status
        Exit Function
    End If
    
    ' 擾ĂȂ΁Al擾B
    strTarget = AoyeHtml.TrimQuote(TargetFile.Tag(lngT).Attrib(lngA).Value)
    
    ' <meta> ^Ȍꍇ refresh ł邱ƂɕĂ̂ŁA
    ' lɐ؂蕪B
    ' Lq : "10;url=http://www.nowhere.com/"
    If TargetFile.Tag(lngT).Name Like "[Mm][Ee][Tt][Aa]" Then
        lngStatus = 0
        lngPointer = InStr(1, strTarget, ";", 0)
        
        If lngPointer = 0 Then  ' ";" Ȃꍇ
            If IsNumeric(strTarget) Then  ' ŜƂ݂ȂȂ΁A
                ' g̃pX strTarget Ƃ݂ȂB
                TargetFile.Tag(lngT).Attrib(lngA).FullPath = TargetFile.Name
            Else  ' łȂȂ΁AsȋLqłB
                lngStatus = 909
            End If
        Else  ' ";" ݂ꍇAȍ~ strTarget ɓȂB
            strTarget = Mid$(strTarget, lngPointer + 1)
            ' 󕶎̏ꍇAg̃pX strTarget Ƃ݂ȂB
            If strTarget = "" Then
                TargetFile.Tag(lngT).Attrib(lngA).FullPath = TargetFile.Name
            ' ꕶȏ゠邪擪 "url=" łȂȂ΁A
            ElseIf Not Left$(strTarget, 4) Like "[Uu][Rr][Ll]=" Then
                lngStatus = 909
            Else  ' 擪 "url=" Ȃ΁Aȍ~ strTarget ɓȂB
                strTarget = Mid$(strTarget, 5)
            End If
        End If
        
        ' lɕsȋLqꍇ
        If lngStatus = 909 Then
            TargetFile.Tag(lngT).Attrib(lngA).Status = lngStatus
            Call AddCheckComment(TargetFile.Tag(lngT).Attrib(lngA).Comment(), _
                                 lngStatus, "content l̋LqsłB")
            VerifyLinkAttribute = lngStatus
            Exit Function
        ' tpXłɎ擾ꂽꍇ
        ElseIf TargetFile.Tag(lngT).Attrib(lngA).FullPath <> "" Then
            VerifyLinkAttribute = 0
            Exit Function
        End If
    End If
    ' <meta> ^OɌA܂ŁB---------
    
    ' ľ`𒲂ׂB
    bytPathType = DetectPathType(strTarget)
    
    ' ut@C̃pXvĂA
    If bytPathType >= 1 And bytPathType <= 5 Then
        If InStr(1, strTarget, "\", 0) Then  ' "\" ̎gɌ肪Ȃ`FbNB
            Select Case CheckSlash(strTarget)
                Case 1  ' "\" ֎~ɂ炸 "\" gĂꍇ
                    lngStatus = 901
                    strMessage = "fBNg̋؂L ""\"" ͎g܂B"
                Case 2  ' "\"  "/" ݂̍NĂꍇ
                    lngStatus = 902
                    strMessage = "fBNg̋؂L ""\""  ""/"" " & _
                                 "݂Ă܂B"
            End Select
            ' G[NĂAel\̂Ɏ߁A֐𔲂B
            If lngStatus > 0 Then
                TargetFile.Tag(lngT).Attrib(lngA).Status = lngStatus
                VerifyLinkAttribute = TargetFile.Tag(lngT).Attrib(lngA).Status
                Call AddCheckComment(TargetFile.Tag(lngT).Attrib(lngA).Comment(), _
                                     lngStatus, strMessage)
                Exit Function
            End If
        End If
    End If
    
    ' l̎ނɉĕB
    Select Case bytPathType
        Case 1, 2  ' [JȐ΃pXLqB
            ' [JȐ΃pXLqĂȂꍇ
            If CheckSet(lnggSetId).AllowLocalFullPath = 0 Then
                lngStatus = 1
                strMessage = "[JȃtpXw͎g܂B"
            Else
                lngStatus = 0
            End If
            ' Status 1 ɂȂĂApXƂĂ͍̗pB
            strFullPath = strTarget
        
        Case 3  ' "//" vgRLq̏ꍇA
            lngStatus = 100
            strFullPath = strTarget
        
        Case 4  ' vgRȂ̐΃pXLqB
            ' s <base> ^OLq̏ꍇ
            If bytBasePathStatus = 0 Then
                lngStatus = 904
                strMessage = "<base> ^ŐLq̂߁A΃pXł܂B"
            ' ƂȂT[ow肳ĂȂꍇ
            ElseIf strBasePathServer = "" Then
                lngStatus = 903
                strMessage = "[g URL w肳ĂȂ߁A" & _
                             "΃pXLq̃vgRƃT[oł܂B"
            Else
                If IsLocalPath(strBasePathServer) Then
                    lngStatus = 0
                Else
                    lngStatus = 100
                End If
                strFullPath = strBasePathServer & strTarget
            End If
            
        Case 5  ' pXLq΃pXLqB
            ' Ŝ[AhXƂ݂ȂꍇB
            If IsMailAddress(strTarget) Then
                ' <a> ^OA邢 RevMade tOĂȂ΁A
                If TargetFile.Tag(lngT).Name Like "[Aa]" Or TargetFile.Tag(lngT).RevMade Then
                    lngStatus = 203
                    strMessage = "[AhX̑O ""mailto:"" KvłB"
                ' <a> ^OȊȌꍇ
                Else
                    lngStatus = 905
                    strMessage = "Ń[AhX͎wł܂B"
                End If
            ' pX̋Lq̏ꍇB
            ElseIf bytBasePathStatus = 0 Then
                lngStatus = 904
                strMessage = "<base> ^ŐLq̂߁A΃pXł܂B"
            ' LȊOȂ΁A΃pXB
            Else
                ' "../" Ŏn܂A܂ւǂ鑊΃N̏ꍇ
                If strTarget Like "..[\/]*" Then
                    ' ΃pX̂ strFullPath ֊i[B
                    Select Case AoyeFilePath.ResolveRelativePath( _
                        strRelativeBaseServer, strRelativeBaseDir(), _
                        strTarget, "", strFullPath)
                        
                        Case 0  ' ɐ΃pXłꍇ
                            ' strRelativeBase* ϐ`FbNZbg URL 
                            ' gpĂȂ΁A
                            If boolRelativeBaseStatus Then
                                ' oオ΃pX܂
                                ' `FbNZbg URL ĂȂ΁A
                                If strFullPath Like CheckSet(lnggSetId).Url & "*" Then
                                    ' [JȊpXɕϊȂB
                                    strFullPath = CheckSet(lnggSetId).LocalPath & _
                                        Mid$(strFullPath, Len(CheckSet(lnggSetId).Url) + 1)
                                    strFullPath = AoyeFilePath.NormalizePathSplitter( _
                                                      strFullPath, "\")
                                    lngStatus = 0
                                ' `FbNZbg URL ȂȂĂ܂A
                                Else
                                    lngStatus = 102
                                    strFullPath = AoyeFilePath.NormalizePathSplitter( _
                                                      strFullPath, "/")
                                    '  `FbNZbg URL Ƀ[gƂOB
                                    '    [JpXw肳ĂP[XɂΉ
                                    '    悢ȂB
                                    
                                    ' xIvVLȂ΁A
                                    If CheckSet(lnggSetId).CheckBaseDirOver <> 0 Then
                                        strMessage = "΃pXfBNg" & _
                                                     "QƂĂ܂B"
                                    End If
                                End If
                            Else
                                If bytBasePathStatus = 2 Then  ' [g URL ̏ꍇA
                                    lngStatus = 100
                                    ' fBNg؂L "/" ɑB
                                    strFullPath = AoyeFilePath.NormalizePathSplitter( _
                                                      strFullPath, "/")
                                Else  ' [JpX̏ꍇ
                                    ' fBNg؂L "\" ɑB
                                    strFullPath = AoyeFilePath.NormalizePathSplitter( _
                                                      strFullPath, "\")
                                    ' pXĂȂ΁A
                                    If AoyeFileList.StrCompDos( _
                                           Left$(strFullPath, _
                                                 Len(CheckSet(lnggSetId).LocalPath)), _
                                           CheckSet(lnggSetId).LocalPath) = 0 Then
                                        lngStatus = 0  ' ȂB
                                    ' pXĂȂȂ΁A
                                    Else
                                        lngStatus = 2
                                        ' xIvVLȂ΁A
                                        If CheckSet(lnggSetId).CheckBaseDirOver <> 0 Then
                                            strMessage = "΃pXfBNg" & _
                                                         "QƂĂ܂B"
                                        End If
                                    End If
                                End If
                            End If
                            
                        Case 1  ' [gz悤Ƃꍇ
                            lngStatus = 907
                            strMessage = "΃NŁA[gfBNg (" & _
                                         strRelativeBaseServer & _
                                         ") ֍sƂ܂B"
                        Case Else  ' ̑̃G[
                            lngStatus = 908
                            strMessage = "΃N̉Ɏs܂B"
                    
                    End Select
                ' "#" n܂AJ[Lq̏ꍇA
                ElseIf Left$(strTarget, 1) = "#" Then
                    lngStatus = 0
                    strFullPath = TargetFile.Name & strTarget
                    ' t@CɂAJ[Ȃ̂A<base> ^OŃ[g URL 
                    ' w肳Ă悤ƁAŃ[JƂȂB
                    
                ' "./" ȂǁA܂œxAւǂ鑊΃N̏ꍇB
                Else
                    If strTarget Like ".[\/]*" Then  ' ` "./" ͍폜B
                        strTarget = Mid$(strTarget, 3)
                    End If
                    ' efBNg̃pXƘAătpXB
                    strFullPath = strBasePathParent & strTarget
                    
                    If bytBasePathStatus = 2 Then  ' [g URL ̏ꍇA
                        lngStatus = 100
                        ' fBNg؂L "/" ɑB
                        strFullPath = AoyeFilePath.NormalizePathSplitter(strFullPath, "/")
                    Else  ' [JpX̏ꍇ
                        lngStatus = 0
                        strFullPath = AoyeFilePath.NormalizePathSplitter(strFullPath, "\")
                    End If
                End If
                
            End If
            
        Case 6  ' pXLq "//" Ȃ̃vgRLqB : "javascript:print..."
            ' "mailto:" ̏ꍇ
            If strTarget Like "[Mm][Aa][Ii][Ll][Tt][Oo]:*" Then
                ' <a> ^OA邢 RevMade tOĂȂ΁A
                If TargetFile.Tag(lngT).Name Like "[Aa]" Or TargetFile.Tag(lngT).RevMade Then
                    ' ":" ȍ~[AhXƂĉ߉\Ȃ΁A
                    If IsMailAddress(Mid$(strTarget, 8)) Then
                        lngStatus = 200  ' ͖B
                    ' [AhXłȂꍇA
                    Else
                        lngStatus = 202
                        ' xIvVLȂ΁A
                        If CheckSet(lnggSetId).CheckMailTo <> 0 Then
                            strMessage = """mailto:"" ̌ɂ̓[AhXKvłB"
                        End If
                    End If
                ' <a> ^OȊOȂ΁A
                Else
                    lngStatus = 905
                    strMessage = "Ń[AhX͎wł܂B"
                End If
            ' "mailto:" ȊȌꍇ́AB
            Else
                lngStatus = 401
            End If
        
        Case 7  ' pXLqij󕶎B
            lngStatus = 906
            strMessage = "lłB"
        
        Case Else  ' DetectPathType() ֐ŉ炩̃G[B
            lngStatus = 999
            strMessage = "l̉߂Ɏs܂B"
    
    End Select
    
    ' [JȃpX́ADOS iDir$ ֐ɓ`j֕ϊB
    If bytPathType = 1 Or bytPathType = 2 Then
        strFullPath = AoyeHtml.FormatAsDosPath(strFullPath)
    End If
    
    ' elZbgB
    If strMessage <> "" Then
        Call AddCheckComment(TargetFile.Tag(lngT).Attrib(lngA).Comment(), _
                             lngStatus, strMessage)
    End If
    TargetFile.Tag(lngT).Attrib(lngA).Status = lngStatus
    TargetFile.Tag(lngT).Attrib(lngA).FullPath = strFullPath

    VerifyLinkAttribute = TargetFile.Tag(lngT).Attrib(lngA).Status
    
    Exit Function
    
ErrorHandler:
    TargetFile.Tag(lngT).Attrib(lngA).Status = 999
    Call AddCheckComment(TargetFile.Tag(lngT).Attrib(lngA).Comment(), _
                         TargetFile.Tag(lngT).Attrib(lngA).Status, _
                         "l̉߂Ɏs܂B")

    VerifyLinkAttribute = TargetFile.Tag(lngT).Attrib(lngA).Status

End Function


'=====================================================================
' vOÍAINI t@Cւ̏݁B
'---------------------------------------------------------------------
Public Function WriteIni( _
    ) As Byte

    On Error GoTo ErrorHandler

    Dim strLineBuffer As String
    Dim lngI As Long
    
    Dim intFileNo As Integer
    intFileNo = FreeFile

    Open strgIniFileName For Output As #intFileNo
    
    Print #intFileNo, "[Settings]"

    If frmMain.WindowState = 0 Then  ' EBhEWԂ̏ꍇ
        Print #intFileNo, "WindowTop=" & frmMain.Top
        Print #intFileNo, "WindowLeft=" & frmMain.Left
    Else  ' EBhEŏԂ̏ꍇ
        Print #intFileNo, "WindowTop=" & lnggLastWindowTop
        Print #intFileNo, "WindowLeft=" & lnggLastWindowLeft
    End If
    Print #intFileNo, "SetId=" & lnggSetId
    Print #intFileNo, "LocalCheck=" & frmMain.chkLocalCheck
    Print #intFileNo, "RemoteCheck=" & frmMain.chkRemoteCheck
    Print #intFileNo, "LogFileDirectory=" & strgLogFileDirectory
    Print #intFileNo, "LogFileIncrement=" & bytgLogFileIncrement
    Print #intFileNo, "LogType=" & bytgLogType
    Print #intFileNo, "AlwaysLogRemoteLink=" & bytgAlwaysLogRemoteLink
    Print #intFileNo, "TrimLogPath=" & bytgTrimLogPath
    Print #intFileNo, "UseSlashLogPath=" & bytgUseSlashLogPath
    Print #intFileNo, "FileNameCaseSensitive=" & bytgFileNameCaseSensitive
    
    Print #intFileNo, ""
    
    For lngI = LBound(CheckSet) To UBound(CheckSet)
        ' vfJ̏ꍇAvf̃`FbNZbg͋󕶎B
        If CheckSet(lngI).SetName = "" Then Exit For
    
        Print #intFileNo, "[Check Set - " & CheckSet(lngI).SetName & "]"
        Print #intFileNo, "LocalPath=" & CheckSet(lngI).LocalPath
        Print #intFileNo, "Url=" & CheckSet(lngI).Url
        Print #intFileNo, "DefaultDocument=" & _
                          AoyeText.JoinStringArray(CheckSet(lngI).DefaultDocument(), ";")
        Print #intFileNo, "HtmlFilePattern=" & _
                          AoyeText.JoinStringArray(CheckSet(lngI).HtmlFilePattern(), ";")
        
        Print #intFileNo, "AllowBackSlash=" & CheckSet(lngI).AllowBackSlash
        Print #intFileNo, "AllowLocalFullPath=" & CheckSet(lngI).AllowLocalFullPath
        Print #intFileNo, "CheckMailTo=" & CheckSet(lngI).CheckMailTo
        Print #intFileNo, "CheckBaseDirOver=" & CheckSet(lngI).CheckBaseDirOver
        Print #intFileNo, "AlertDirListing=" & CheckSet(lngI).AlertDirListing
        Print #intFileNo, "StrictAnchorDescription=" & CheckSet(lngI).StrictAnchorDescription
        Print #intFileNo, "AlertIgnoredFile=" & CheckSet(lngI).AlertIgnoredFile
        Print #intFileNo, "AlertIgnoredNameAnchor=" & CheckSet(lngI).AlertIgnoredNameAnchor
        Print #intFileNo, "AlertIgnoredIdAnchor=" & CheckSet(lngI).AlertIgnoredIdAnchor
        
        Print #intFileNo, "FileAttribute=" & CheckSet(lngI).FileAttribute
        Print #intFileNo, "FilePatternXEnabled=" & CheckSet(lngI).FilePatternXEnabled
        Print #intFileNo, "FilePatternX=" & _
                              AoyeText.JoinStringArray(CheckSet(lngI).FilePatternX(), ";")
        Print #intFileNo, "DirAttribute=" & CheckSet(lngI).DirAttribute
        Print #intFileNo, "DirPatternXEnabled=" & CheckSet(lngI).DirPatternXEnabled
        Print #intFileNo, "DirPatternX=" & _
                              AoyeText.JoinStringArray(CheckSet(lngI).DirPatternX(), ";")
        Print #intFileNo, ""
    Next lngI
    
    Close #intFileNo

    Exit Function
    
ErrorHandler:

End Function


'=====================================================================
' HtmlFile() ̊evfJāAO֏oB
'---------------------------------------------------------------------
'  : strLogFileName : oOt@C̃tpXB
'---------------------------------------------------------------------
' ߂l : 0 ȏ : oꂽxB
'         -1 : G[I
'---------------------------------------------------------------------
Public Function WriteLog( _
    strLogFileName As String) As Long

    On Error GoTo ErrorHandler
    
    Dim CurrentFile As HtmlFileStructure
    Dim CurrentTag As HtmlTag
    Dim CurrentAttrib As HtmlAttribute
    
    Const strIndent As String = "  "
    Dim strLogBuffer As String  ' Ot@CɏoSe߂obt@B
    Dim strFileBuffer As String  ' t@CPʂ̃obt@B TXT `ŎgpB
    Dim strLineBuffer As String  ' sPʂ̃obt@B^u؂ TXTACSV ŎgpB
    
    Dim lngF As Long
    Dim lngT As Long
    Dim lngA As Long
    Dim lngI As Long
    
    Dim lngAlertCounter As Long  ' x̃JE^B
    Dim strFilePath As String  ' Oɏot@C̃pXB
    Dim strLinkToFullPath As String  ' ÑtpXB
    
    Dim boolLocalCheck As Boolean
    Dim boolRemoteCheck As Boolean
    If frmMain.chkLocalCheck.Value = 1 Then boolLocalCheck = True
    If frmMain.chkRemoteCheck.Value = 1 Then boolRemoteCheck = True
    
    Dim strMessage As String
    Dim strAlertId As String
    
    '---------------------------
    
    ' ܂AÕwb_쐬B
    
    strLogBuffer = App.ProductName & " (Version " & App.Major & "." & _
                   Format$(App.Minor, "00") & ") `FbN" & vbCrLf & vbCrLf
    
    If bytgLogType = 0 Then
        strLogBuffer = strLogBuffer & _
                       String$(40, "=") & vbCrLf & _
                       "`FbNZbg : " & CheckSet(lnggSetId).SetName & vbCrLf & _
                       "fBNg : " & CheckSet(lnggSetId).LocalPath & vbCrLf & _
                       " : " & Date$ & " " & Time$ & vbCrLf & _
                       String$(40, "=") & vbCrLf & vbCrLf
    Else
        strLineBuffer = "`FbNZbg" & vbTab & CheckSet(lnggSetId).SetName
        ' KvȂ CSV `֕ϊB
        If bytgLogType = 1 Then strLineBuffer = AoyeText.TabTxtToCsv(strLineBuffer)
        strLogBuffer = strLogBuffer & strLineBuffer & vbCrLf
        
        strLineBuffer = "fBNg" & vbTab & CheckSet(lnggSetId).LocalPath
        If bytgLogType = 1 Then strLineBuffer = AoyeText.TabTxtToCsv(strLineBuffer)
        strLogBuffer = strLogBuffer & strLineBuffer & vbCrLf
        
        strLineBuffer = "" & vbTab & Date$ & " " & Time$
        If bytgLogType = 1 Then strLineBuffer = AoyeText.TabTxtToCsv(strLineBuffer)
        strLogBuffer = strLogBuffer & strLineBuffer & vbCrLf & vbCrLf
    End If
   
    '---------------------------
    
    ' \g݂̃wb_쐬B
    If bytgLogType > 0 Then
        strLineBuffer = "t@C" & vbTab & "s" & vbTab & _
                        "^O" & vbTab & "" & vbTab & "l" & vbTab & _
                        "N" & vbTab & "x ID" & vbTab & "xe"
        If bytgLogType = 1 Then strLineBuffer = AoyeText.TabTxtToCsv(strLineBuffer)
        strLogBuffer = strLogBuffer & strLineBuffer & vbCrLf
    End If
    
    '---------------------------

    ' ꂼ̃t@CɂāA
    For lngF = LBound(HtmlFile) To UBound(HtmlFile)
        
        CurrentFile = HtmlFile(lngF)
        
        ' ̃t@CoĂAXg̖܂łƂ݂ȂB
        If CurrentFile.Name = "" Then Exit For
        
        ' HTML t@CȊOȂ΁ABcontinue B
        'If CurrentFile.Status = 1 Then GoTo LoopF_End
        
        strFileBuffer = ""
        
        ' OɋLqt@C쐬B
        strFilePath = CurrentFile.Name
        If bytgTrimLogPath = 1 Then  ' pX̓g~OꍇB
            strFilePath = Mid$(strFilePath, Len(CheckSet(lnggSetId).LocalPath) + 1)
        End If
        If bytgUseSlashLogPath = 1 Then  ' fBNg؂L "/" gꍇB
            strFilePath = AoyeFilePath.NormalizePathSplitter(strFilePath, "/")
        End If
        
        ' t@CxŌx݂Ȃ΁A
        'If CurrentFile.Status >= 2 Then
            If CurrentFile.Comment(0).Message <> "" Then
                For lngI = LBound(CurrentFile.Comment) To UBound(CurrentFile.Comment)
                    lngAlertCounter = lngAlertCounter + 1
                    If bytgLogType = 0 Then
                        strFileBuffer = strFileBuffer & strIndent & _
                                        CurrentFile.Comment(lngI).Message & " [" & _
                                        ConvertAlertId(1, CurrentFile.Comment(lngI).Id) & _
                                        "]" & vbCrLf
                                        
                                        
                    Else
                        strLineBuffer = strFilePath & _
                                       vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & _
                                       ConvertAlertId(1, CurrentFile.Comment(lngI).Id) & _
                                       vbTab & CurrentFile.Comment(lngI).Message
                        If bytgLogType = 1 Then  ' KvȂ CSV `֕ϊB
                            strLineBuffer = AoyeText.TabTxtToCsv(strLineBuffer)
                        End If
                        strLogBuffer = strLogBuffer & strLineBuffer & vbCrLf
                    End If
                Next lngI
                If bytgLogType = 0 Then
                    strFileBuffer = strFileBuffer & vbCrLf
                End If
            End If
        'End If
        
        ' ^O̐؂oɐ HTML t@CłȂA炩̌xǉĂȂ΁A
        If CurrentFile.Status > 0 And strFileBuffer <> "" Then
            '  Text tH[}bgȂ΃Opobt@ɒǉB
            If bytgLogType = 0 Then
                strLogBuffer = strLogBuffer & _
                               " " & strFilePath & vbCrLf & vbCrLf & strFileBuffer
            End If
            GoTo LoopF_End  ' continue B
        End If
    
        ' ꂼ̃^OɂāA
        For lngT = LBound(CurrentFile.Tag) To UBound(CurrentFile.Tag)
        
            CurrentTag = CurrentFile.Tag(lngT)
        
            If CurrentTag.Name = "" Then Exit For
        
            ' ^OxŌx݂Ȃ΁A
            If CurrentTag.Comment(0).Message <> "" Then
                For lngI = LBound(CurrentTag.Comment) To UBound(CurrentTag.Comment)
                    lngAlertCounter = lngAlertCounter + 1
                    If bytgLogType = 0 Then
                        strFileBuffer = strFileBuffer & strIndent & "y" & _
                                        CurrentTag.Line & " sځz <" & _
                                        CurrentTag.Name & "> ^O" & _
                                        vbCrLf & strIndent & strIndent & _
                                        CurrentTag.Comment(lngI).Message & " [" & _
                                        ConvertAlertId(2, CurrentTag.Comment(lngI).Id) & _
                                        "]" & vbCrLf
                    Else
                        strLineBuffer = strFilePath & vbTab & _
                                        CurrentTag.Line & vbTab & _
                                        CurrentTag.Name & vbTab & vbTab & vbTab & vbTab & _
                                        ConvertAlertId(2, CurrentTag.Comment(lngI).Id) & _
                                        vbTab & CurrentTag.Comment(lngI).Message
                        If bytgLogType = 1 Then  ' KvȂ CSV `֕ϊB
                            strLineBuffer = AoyeText.TabTxtToCsv(strLineBuffer)
                        End If
                        strLogBuffer = strLogBuffer & strLineBuffer & vbCrLf
                    End If
                Next lngI
                If bytgLogType = 0 Then
                    strFileBuffer = strFileBuffer & vbCrLf
                End If
            End If
        
            ' ꂼ̑ɂāA
            For lngA = LBound(CurrentTag.Attrib) To UBound(CurrentTag.Attrib)
                
                CurrentAttrib = CurrentTag.Attrib(lngA)
                
                If CurrentAttrib.Name = "" Then Exit For
                
                strLinkToFullPath = ""
                
                '  Status u`FbNvȂ΁A
                ' rLZꂽ̂ƂĂ̎|̃bZ[WǉB
                strMessage = ""
                Select Case CurrentAttrib.Status
                    Case Is < 10  ' `FbÑ[J N
                        If boolLocalCheck = True Then
                            strMessage = "rLZꂽ߁A`FbNB"
                        End If
                    ' `FbÑ[g N
                    Case Is >= 100 And CurrentAttrib.Status < 110
                        If boolRemoteCheck = True Then
                            strMessage = "rLZꂽ߁A`FbNB"
                        ElseIf bytgAlwaysLogRemoteLink = 1 Then
                            strMessage = "[gւ̃NB"
                        End If
                End Select
                ' ǉbZ[WȂ΁AzɒǉB
                If strMessage <> "" Then
                    Call AddCheckComment(CurrentAttrib.Comment, 990, strMessage)
                End If
                
                ' xŌx݂Ȃ΁A
                If CurrentAttrib.Comment(0).Message <> "" Then
                
                    ' Oɕ\AÑtpX擾B
                    strLinkToFullPath = LogFullPath(CurrentAttrib)
                    
                    '  TXT o͂Ȃ΁ATuwb_óB
                    If bytgLogType = 0 Then
                        strFileBuffer = strFileBuffer & _
                            strIndent & "y" & _
                            CurrentAttrib.Line & " sځz <" & _
                            CurrentTag.Name & "> ^O " & _
                            CurrentAttrib.Name & " l " & _
                            CurrentAttrib.Value
                        If strLinkToFullPath <> "" Then
                            strFileBuffer = strFileBuffer & _
                                            " ( " & strLinkToFullPath & ")"
                        End If
                        strFileBuffer = strFileBuffer & vbCrLf
                    End If
                    
                    ' {Bꂼ̌xɂāA
                    For lngI = LBound(CurrentAttrib.Comment) To _
                               UBound(CurrentAttrib.Comment)
                        ' rLZ̃bZ[WłȂȂ΁AxƂăJEgB
                        If CurrentAttrib.Comment(lngI).Id <> 990 Then
                            lngAlertCounter = lngAlertCounter + 1
                            ' ܂AOɌx ID LB
                            strAlertId = ConvertAlertId(3, CurrentAttrib.Comment(lngI).Id)
                            If bytgLogType = 0 Then
                                strAlertId = " [" & strAlertId & "]"
                            End If
                        ' rLZ̏ꍇ́AJEgȂAx ID \ȂB
                        Else
                            strAlertId = ""
                        End If
                        
                        If bytgLogType = 0 Then
                            strFileBuffer = strFileBuffer & _
                                strIndent & strIndent & _
                                CurrentAttrib.Comment(lngI).Message & _
                                strAlertId & vbCrLf
                        Else
                            strLineBuffer = _
                                strFilePath & vbTab & _
                                CurrentAttrib.Line & vbTab & _
                                CurrentTag.Name & vbTab & _
                                CurrentAttrib.Name & vbTab & _
                                CurrentAttrib.Value & vbTab & _
                                strLinkToFullPath & vbTab & _
                                strAlertId & vbTab & _
                                CurrentAttrib.Comment(lngI).Message
                            If bytgLogType = 1 Then  ' KvȂ CSV `֕ϊB
                                strLineBuffer = AoyeText.TabTxtToCsv(strLineBuffer)
                            End If
                            strLogBuffer = strLogBuffer & strLineBuffer & vbCrLf
                        End If
                    Next lngI
                    If bytgLogType = 0 Then
                        strFileBuffer = strFileBuffer & vbCrLf
                    End If
                End If
                
            Next lngA
            
        Next lngT
        
        '  Text tH[}bg̃OŁA炩̌xoĂꍇB
        If bytgLogType = 0 And strFileBuffer <> "" Then
            strLogBuffer = strLogBuffer & _
                           " " & strFilePath & vbCrLf & vbCrLf & strFileBuffer
        End If
    
LoopF_End:
    Next lngF

    If lngAlertCounter = 0 Then
        strLogBuffer = strLogBuffer & vbCrLf & "ixׂ_͂܂j"
    Else
        strLogBuffer = strLogBuffer & vbCrLf & _
            String$(40, "-") & vbCrLf & vbCrLf & _
            "iꂼ̌xbZ[W̖ ""[]"" Ōxԍ" & _
            "Ă܂B" & vbCrLf & _
            "  wv́uxbZ[WꗗvŁAebZ[Ŵڂ" & _
            vbCrLf & "  Ώ@ǂނƂł܂Bj" & vbCrLf
    End If

    ' Ot@Cւ̏osȂB
    If AoyeFileIo.WriteTextFile(strLogFileName, strLogBuffer, 0, 0) = 0 Then
       GoTo ErrorHandler
    End If

    WriteLog = lngAlertCounter

    Exit Function
    
ErrorHandler:
    WriteLog = -1

End Function

